<?php
// ++=========================================================================++
// || vBadvanced CMPS v2.2.1 - Russian (Repack)
// ||  2003-2007 vBadvanced.com & PlurPlanet, LLC -   
// ||  : Lazek  zCarot.
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);

require_once('./global.php');
require_once('./includes/adminfunctions_template.php');
require_once('./includes/adminfunctions_language.php');
require_once('./includes/adminfunctions_vba_cmps.php');

$scriptname = 'CMPS';
$version = '2.2.1';
$scriptfile = 'vbacmps_install';

define('PRODUCT_CODE', 'adv_cmps');

print_cp_header(' vBadvanced ' . $scriptname . '', '', '<style type="text/css">
<!--
.redalert
{
	background: #FF0000;
	color: #000000;
}
-->
</style>');

if (substr($vbulletin->options['templateversion'], 0, 3) != 3.6)
{
	echo '  ,     vBadvanced ' . $scriptname . '  vBulletin 3.6.x     vBulletin.<br />,   <a href="http://www.vbadvanced.com/">vbadvanced.com</a>    vBadvanced ' . $scriptname . ',     vBulletin, ,    ,     vBulletin 3.6.';
	exit;
}

if (!is_object($db))
{
	echo '  ,     vBadvanced ' . $scriptname . '   vBulletin <b>3.6</b>   vBulletin <b>3.5</b>.<br />,   <a href="http://www.vbadvanced.com/">vbadvanced.com</a>     vBulletin <b>3.5</b>.';
	exit;
}

if (!$_REQUEST['do'])
{
	$_REQUEST['do'] = 'installstart';
}

// ##################### Delete Template Function #####################
function kill_template($title, $printphrase = 0)
{
	global $db;

	$db->query_write("DELETE FROM " . TABLE_PREFIX . "template WHERE title = '$title'");

	return '<div class="smallfont">  ' . $title . '</div>';
}

// ##### Insert all templates #################################################
function insert_all_templates()
{
	global $maintemplates, $db;
	
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "template WHERE title IN('" . implode("', '", array_keys($maintemplates)) . "') AND styleid = '-1'");

	foreach ($maintemplates AS $name => $content)
	{
		$tempinsert .= "(
  		'$name',
  		'" . $db->escape_string(compile_template($content)) . "',
  		'" . $db->escape_string($content) ."',
  		'-1',
  		'template',
  		" . TIMENOW . ",
  		'vBadvanced',
  		'$version',
  		'" . PRODUCT_CODE . "'
		),";		
	}
	
  $db->query_write("
  	INSERT INTO " . TABLE_PREFIX . "template
  		(title, template, template_un, styleid, templatetype, dateline, username, version, product)
  	VALUES
  		" . substr($tempinsert, 0, strlen($tempinsert) - 1)
  );
	
}


// ##################### Insert Settings Function #####################
function insert_setting()
{
	global $db, $varname, $setting, $grouptitle;

	if (!$varname)
	{
		return false;
	}

	$checksetting = $db->query_first("SELECT varname FROM " . TABLE_PREFIX . "adv_setting WHERE varname = '$varname' AND grouptitle = '$grouptitle'");

	if ($checksetting['varname'])
	{
		return false;
	}

	$db->query_write("
		INSERT INTO " . TABLE_PREFIX . "adv_setting
			(varname, grouptitle, value, defaultvalue, optioncode, displayorder)
		VALUES (
			'$varname',
			'" . $grouptitle . "',
			'" . $db->escape_string($setting['value']) . "',
			'" . $db->escape_string($setting['defaultvalue']) . "',
			'" . $db->escape_string($setting['optioncode']) . "',
			" . $setting['displayorder'] . "
	)");

	$phrasetypeid = 'vbsettings';

	return '<div class="smallfont">  - ' . $title . '</div>';

}

// ##################### Update Settings Function #####################
function update_setting($phraseonly = false)
{
  global $db, $varname, $setting, $grouptitle;

	if (!$varname)
	{
		return false;
	}

	$oldvarname = $varname;

	$phrasetypeid = 'vbsettings';

	// Title phrase
	update_phrase('setting_' . $varname . '_title', $setting['title']);

	// Description phrase
	update_phrase('setting_' . $varname . '_desc', $setting['description']);

	if ($phraseonly)
	{
		return false;
	}

	$varname = $oldvarname;

	$db->query_write("
		UPDATE " . TABLE_PREFIX . "adv_setting SET
			defaultvalue = '" . $db->escape_string($setting['defaultvalue']) . "',
			optioncode = '" . $db->escape_string($setting['optioncode']) . "',
			displayorder = $setting[displayorder],
			grouptitle = '$grouptitle'
		WHERE varname = '$varname' AND grouptitle = '$grouptitle'
	");

	return '<div>  - ' . $varname . '</div>';
}

// ##################### Delete Setting Function #####################
function kill_setting($printphrase = 0)
{
  global $db, $varname, $grouptitle;

	if ($grouptitle == 'adv_global')
	{
		return;
	}

	$db->query_write("DELETE FROM " . TABLE_PREFIX . "adv_setting WHERE varname = '$varname' AND grouptitle = '$grouptitle'");

	kill_phrase('setting_" . $title . "_title');
	kill_phrase('setting_" . $title . "_desc');

	return '<div class="smallfont">  - ' . $title . '</div>';
}

// ##### Insert Phrase Function ###############################################
function insert_phrase($forcevarname = '', $forcetext = '')
{
	global $db, $phrasetypeid, $varname, $text, $version;

	if ($forcevarname)
	{
		$varname = $forcevarname;
		$text = $forcetext;
	}

	kill_phrase();

	$db->query_write("
		INSERT INTO " . TABLE_PREFIX . "phrase
			(languageid, varname, text, fieldname, product, username, dateline, version)
		VALUES (
			'-1',
			'" . $varname . "',
			'" . $db->escape_string($text) ."',
			'$phrasetypeid',
			'" . PRODUCT_CODE . "',
			'vBadvanced',
			" . TIMENOW . ",
			'$version'
	)");

	return '<div class="smallfont">  - ' . $varname . '</div>';
}

// ##### Update Phrase Function ###############################################
function update_phrase($forcevarname = '', $forcetext = '')
{
	global $db, $varname, $text, $phrasetypeid, $version;

	if ($forcevarname)
	{
		$varname = $forcevarname;
		$text = $forcetext;
	}

	// Insert first, just to make sure it's really there
	$db->query_write("
		INSERT IGNORE INTO " . TABLE_PREFIX . "phrase
			(languageid, varname, text, fieldname, product, username, dateline, version)
		VALUES (
			'-1',
			'" . $varname . "',
			'" . $db->escape_string($text) ."',
			'$phrasetypeid',
			'" . PRODUCT_CODE . "',
			'vBadvanced',
			" . TIMENOW . ",
			'$version'
	)");

	$db->query_write("
		UPDATE " . TABLE_PREFIX . "phrase SET
			text = '" . $db->escape_string($text) ."',
			dateline = " . TIMENOW . ",
			version = '$version',
			username = 'vBadvanced'
		WHERE varname = '$varname'
			AND fieldname = '$phrasetypeid'
			AND product = '" . PRODUCT_CODE . "'
			AND languageid = '-1'
	");

	return '<div class="smallfont">  - ' . $varname . '</div>';
}

// ##################### Delete Phrase Function #####################
function kill_phrase($forcevarname = '')
{
	global $db, $varname, $phrasetypeid;

	if ($forcevarname)
	{
		$varname = $forcevarname;
	}

	$db->query_write("
		DELETE FROM " . TABLE_PREFIX . "phrase
		WHERE varname = '$varname'
			AND fieldname = '$phrasetypeid'
			AND product = '" . PRODUCT_CODE . "'
			AND languageid = '-1'
	");

	return '<div class="smallfont">  ' . $varname . '</div>';
}

// ##### Complete Phrase Insert/Delete ########################################
function insert_all_phrases()
{
	global $db, $mainphrases, $mainsettings, $version;

	// Settings phrases
	foreach ($mainsettings AS $grouptitle => $settings)
	{
		foreach ($settings AS $varname => $setting)
		{
			$mainphrases['vbsettings']['setting_' . $varname . '_title'] = $setting['title'];
			$mainphrases['vbsettings']['setting_' . $varname . '_desc'] = $setting['description'];
		}
	}

	// Main phrases
	foreach ($mainphrases AS $fieldname => $phrases)
	{
		$db->query_write("
			DELETE FROM " . TABLE_PREFIX . "phrase
			WHERE fieldname = '$fieldname'
				AND varname IN('" . implode("','", array_keys($phrases)) . "')
				AND languageid = '-1'
		");

		$insertquery = '';
		foreach ($phrases AS $varname => $text)
		{
			$insertquery .= "('-1', '$varname', '" . $db->escape_string($text) . "', '$fieldname', '" . PRODUCT_CODE . "', 'vBadvanced', " . TIMENOW . ", '$version'),";
		}

		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "phrase
				(languageid, varname, text, fieldname, product, username, dateline, version)
			VALUES
				" . substr($insertquery, 0, strlen($insertquery) - 1)
		);
	}

	build_language(-1);

}

// ##### Install Table Start Function #########################################
function print_install_table_start($title = '', $reqdo = '')
{
	global $scriptfile, $scriptname;

	if ($reqdo)
	{
		print_form_header($scriptfile, $reqdo);
	}
	else
	{
		echo '<form action="' . $scriptfile . '.php" method="post"><input type="hidden" name="adminhash" value="' . ADMINHASH . '" />';
		print_table_start();
	}

	if (!$title)
	{
		$title = ' vBadvanced ' . $scriptname;
	}

	print_table_header($title);
}

// ##### Install End Table Function ###########################################
function print_install_table_end()
{
	global $stepphrase, $scriptname, $step, $nextstep, $nextdo, $rebuildtemp, $nocontinue, $_REQUEST, $forumsoff;

	print_description_row('<div style="padding:12px;">' . $stepphrase . '</div>');

	if ($_REQUEST['do'] == 'installstart')
	{
                print_radio_row('', 'do', array('install' => '  .', 'upgrade' => '.', 'templates' => ' .', 'phrases' => ' .', 'doimages' => '    .', 'uninstall' => ' vBadvanced ' . $scriptname . '.'), 'install');
	}

	construct_hidden_code('step', iif($nextstep, $nextstep, $step + 1));

	if ($nextdo != 'closeforums')
	{
		construct_hidden_code('forumsoff', $forumsoff);
	}

	if ($nextdo)
	{
		construct_hidden_code('do', $nextdo);
	}

	print_table_break();

	if ($rebuildtemp)
	{
		build_all_styles(0, 0);
	}

	if ($nocontinue)
	{
		print_table_footer();
	}
	else
	{
		print_submit_row('', '');
	}
}

// ##### Check for and add indexes ############################################
function add_table_index($table, $column)
{
	global $db;
	$indexcheck = $db->query("SHOW KEYS FROM " . TABLE_PREFIX . $table);
	while ($icheck = $db->fetch_array($indexcheck))
	{
		if ($icheck['Column_name'] == $column AND $icheck['Seq_in_index'] == 1)
		{
			return;
		}
	}
	$db->query_write("ALTER TABLE " . TABLE_PREFIX . "$table ADD INDEX ($column)");
}

// ##### Insert Plugins #######################################################
function insert_plugins()
{
	global $db, $vba_plugins;

	foreach ($vba_plugins AS $devkey => $plugin)
	{
		$plugin['devkey'] = $devkey;

		if (!$plugin['product'])
		{
			$plugin['product'] = PRODUCT_CODE;
		}
		$plugin['active'] = 1;

		$plugcheck = $db->query_first("SELECT devkey FROM " . TABLE_PREFIX . "plugin WHERE devkey = '$devkey'");

		$db->query_write(fetch_query_sql($plugin, 'plugin', iif($plugcheck['devkey'], "WHERE devkey = '$devkey'", '')));
	}

	vBulletinHook::build_datastore($db);
}

// ############################################################################
// Arrays
// ############################################################################

// ##### Templates ############################################################
$maintemplates = array(
'adv_portal' =>

'$stylevar[htmldoctype]
<html dir="$stylevar[textdirection]" lang="$stylevar[languagecode]">
<head>
<title>$vboptions[hometitle] <if condition="$pagetitle">- $pagetitle</if></title>

$headinclude

<if condition="$show[\'inlinemod\']"><script type="text/javascript" src="clientscript/vbulletin_inlinemod.js"></script></if>

</head>
<body>

$header

$navbar

<table align="center" class="page" cellspacing="0" cellpadding="0" width="100%">
<tr valign="top">

<if condition="$show[\'left_column\']">

<td width="$vba_style[portal_leftcolwidth]">

$home[leftblocks]

</td>

<!-- Spacer Cell -->
<td width="$vba_style[portal_colspacing]"><img alt="" src="$vboptions[bburl]/$vboptions[cleargifurl]" width="$vba_style[portal_colspacing]" /></td>
<!-- / Spacer Cell -->

</if>


<if condition="$show[\'center_column\']">
<td valign="top">

$home[centerblocks]

</td>
</if>


<if condition="$show[\'right_column\']">

<!-- Spacer Cell -->
<td width="$vba_style[portal_colspacing]"><img alt="" src="$vboptions[bburl]/$vboptions[cleargifurl]" width="$vba_style[portal_colspacing]" /></td>
<!-- / Spacer Cell -->

<td valign="top" width="$vba_style[portal_rightcolwidth]">

$home[rightblocks]

</td>
</if>

</tr>
</table>

$footer

</body>
</html>',



'adv_portal_buddylistbits' =>

'<div class="smallfont" style="margin-bottom:2px">
	<span style="float:$stylevar[right]">
	<a href="$vboptions[bburl]/private.php?$session[sessionurl]do=newpm&amp;u=$loggedin[userid]" title="<phrase 1="$loggedin[username]">$vbphrase[send_private_message_to_x]</phrase>">$vbphrase[pm]</a>
	<a href="$vboptions[bburl]/profile.php?$session[sessionurl]do=removelist&amp;userlist=buddy&amp;u=$loggedin[userid]" title="$vbphrase[remove_from_buddy_list]">X</a>
	</span>
	<a href="$vboptions[bburl]/member.php?$session[sessionurl]u=$loggedin[userid]">$loggedin[username]</a> $loggedin[invisiblemark]
</div>',



'adv_portal_calendar_day' =>

'<td class="<if condition="$show[\'highlightweek\']">alt1<else />alt2</if>"<if condition="$show[\'highlighttoday\']"> style="border:solid 1px red; font-weight:bold" title="$vbphrase[today]"</if>>
	<if condition="$show[\'daylink\']">
		<span class="smallfont"><a href="$vboptions[bburl]/calendar.php?$session[sessionurl]do=getinfo&amp;day=$year-$month-$day&amp;c=$calendarid" title="$eventdesc">$day</a></span>
	<else />
		<span class="smallfont">$day</span>
	</if>
</td>',



'adv_portal_calendar_day_other' =>

'<td class="alt1"><span class="smallfont">$day</span></td>',



'adv_portal_calendar_header' =>

'<tr>
	<if condition="$show[\'day1\']"><td align="center" class="thead">$day1</td></if>
	<if condition="$show[\'day2\']"><td align="center" class="thead">$day2</td></if>
	<if condition="$show[\'day3\']"><td align="center" class="thead">$day3</td></if>
	<if condition="$show[\'day4\']"><td align="center" class="thead">$day4</td></if>
	<if condition="$show[\'day5\']"><td align="center" class="thead">$day5</td></if>
	<if condition="$show[\'day6\']"><td align="center" class="thead">$day6</td></if>
	<if condition="$show[\'day7\']"><td align="center" class="thead">$day7</td></if>
</tr>
$calendarrowbits
',



'adv_portal_calendar_week' =>

'<tr align="center">
	$calendardaybits
</tr>
',



'adv_portal_footer' =>

'<!--     .     ! -->

<div align="center" class="smallfont"><phrase 1="$vba_options[portal_version]">$vbphrase[powered_by_vbadvanced_cmps]</phrase></div>',



'adv_portal_latestthreads_head' =>

'<tr>
	<if condition="$mod_options[\'portal_threads_showicon\']">
		<td class="thead" width="5">&nbsp;</td>
	</if>
	<td class="thead" width="100%">$vbphrase[title_username_date]</td>
	<if condition="$mod_options[\'portal_threads_lastpost\']">
		<td align="center" class="thead" nowrap="nowrap" width="25%">$vbphrase[last_post]</td>
	</if>
	<td class="thead" width="15">$vbphrase[replies]</td>
	<td class="thead" width="15">$vbphrase[views]</td>
	<if condition="$mod_options[\'portal_threads_showforum\']">
		<td align="center" class="thead" width="10%">$vbphrase[forum]</td>
	</if>
</tr>',



'adv_portal_latesttopicbits' =>

'<if condition="$mods[\'modcol\'] == 1">

	<tr>
		<if condition="$mod_options[\'portal_threads_showicon\']">
			<td class="alt2"><if condition="$show[\'threadicon\']"><img alt="" border="0" src="$thread[threadiconpath]" title="$thread[threadicontitle]" /></if></td>
		</if>

		<td class="alt1">
			<if condition="$thread[\'subscribed\']">
				<span style="float:$stylevar[right]"><img alt="" class="inlineimg" src="$stylevar[imgdir_misc]/subscribed.gif" title="$vbphrase[you_are_subscribed_to_this_thread]" /></span>
			</if>
			<a href="$vboptions[bburl]/showthread.php?t=$thread[threadid]" title="$thread[preview]"><if condition="$show[\'gotonewpost\']"><strong>$thread[title]</strong><else />$thread[title]</if></a>

			<if condition="$thread[\'rating\']">
				<span style="float:$stylevar[right]"><img alt="" src="$stylevar[imgdir_rating]/rating_$thread[rating].gif" title="<phrase 1="$thread[votenum]" 2="$thread[voteavg]">$vbphrase[thread_rating_x_votes_y_average]</phrase>" /></span>
			</if>

		<div class="smallfont"><span style="cursor:pointer" onclick="window.open(\'$vboptions[bburl]/member.php?$session[sessionurl]u=$thread[postuserid]\')">$thread[postusername]</span>

		</div>
		<if condition="$mod_options[\'portal_threads_showdate\']"><div class="smallfont">$thread[postdate] $thread[posttime]</div></if>
		</td>
		<if condition="$show[\'lastpost\']">
			<td class="alt2">
				<div class="smallfont" style="text-align:right; white-space:nowrap">$thread[lastpostdate] <span class="time">$thread[lastposttime]</span><br /><phrase 1="$vboptions[bburl]/member.php?$session[sessionurl]find=lastposter&amp;t=$thread[threadid]" 2="$thread[lastposter]">$vbphrase[by_x]</phrase> <a href="$vboptions[bburl]/showthread.php?$session[sessionurl]p=$thread[lastpostid]#post$thread[lastpostid]"><img alt="" border="0" src="$stylevar[imgdir_button]/lastpost.gif" title="$vbphrase[go_to_last_post]" /></a></div>
			</td>
		</if>
		<td align="center" class="$class_reply"><span class="smallfont">$thread[replycount]</span></td>

		<td align="center" class="$class_view"><span class="smallfont">$thread[views]</span></td>
			<if condition="$mod_options[\'portal_threads_showforum\']">
				<td class="$class_ftitle"><span class="smallfont"><a href="$vboptions[bburl]/forumdisplay.php?$session[sessionurl]f=$thread[forumid]">$thread[forumtitle]</a></span></td>
			</if>
	</tr>

<else />

	<tr>
		<td class="$bgclass">
			<if condition="$show[\'threadicon\']">
				<img alt="" src="$thread[threadiconpath]" border="0" title="$thread[threadicontitle]" />
			</if>
			<if condition="$thread[\'subscribed\']">
				<img alt="" class="inlineimg" src="$stylevar[imgdir_misc]/subscribed.gif" title="$vbphrase[you_are_subscribed_to_this_thread]" />
			</if>
			<span class="smallfont"><a href="$vboptions[bburl]/showthread.php?t=$thread[threadid]" title="<if condition="$thread[preview]">$thread[preview]

</if>$vbphrase[by] $thread[postusername] <if condition="$mod_options[\'portal_threads_showdate\']">$thread[postdate] $thread[posttime]</if>"><if condition="$show[\'gotonewpost\']"><strong>$thread[title]</strong><else />$thread[title]</if></a></span>

			<if condition="$thread[\'rating\']">
				<div style="margin-top:4px"><img alt="" src="$stylevar[imgdir_rating]/rating_$thread[rating].gif" title="<phrase 1="$thread[votenum]" 2="$thread[voteavg]">$vbphrase[thread_rating_x_votes_y_average]</phrase>" /></div>
			</if>
			<if condition="$show[\'lastpost\']">
				<div class="smallfont" style="margin-top:4px"><a href="$vboptions[bburl]/showthread.php?$session[sessionurl]p=$thread[lastpostid]#post$thread[lastpostid]"><img alt="" border="0" src="$stylevar[imgdir_button]/lastpost.gif" title="$vbphrase[go_to_last_post]" /></a> $vbphrase[last_post_by] <a href="$vboptions[bburl]/member.php?find=lastposter&amp;t=$thread[threadid]">$thread[lastposter]</a></div>
				<div class="smallfont">$thread[lastpostdate] <span class="time">$thread[lastposttime]</span></div>
			</if>

			<if condition="$mod_options[\'portal_threads_showforum\']">
				<div class="smallfont"><a href="$vboptions[bburl]/forumdisplay.php?$session[sessionurl]f=$thread[forumid]">$thread[forumtitle]</a></div>
			</if>
		<div class="smallfont">$thread[replycount] $vbphrase[replies], $thread[views] $vbphrase[views]</div></td>
	</tr>
</if>',



'adv_portal_moderation' =>

'<tr>
	<td class="$bgclass">
		<if condition="$show[\'threads\']">
			<div><phrase 1="$threads[count]" 2="$modcpdir/moderate.php?do=posts">$vbphrase[x_threads]</phrase></div>
		</if>
		<if condition="$show[\'posts\']">
			<div><phrase 1="$posts[count]" 2="$modcpdir/moderate.php?do=posts#postlist">$vbphrase[x_posts]</phrase></div>
		</if>
		<if condition="$show[\'events\']">
			<div><phrase 1="$events[count]" 2="$modcpdir/moderate.php?do=events">$vbphrase[x_events]</phrase></div>
		</if>
		<if condition="$show[\'attachments\']">
			<div><phrase 1="$attachments[count]" 2="$modcpdir/moderate.php?do=attachments">$vbphrase[x_attachment]</phrase></div>
		</if>
		<div><phrase 1="$users[count]" 2="$admincpdir/user.php?do=moderate">$vbphrase[x_users]</phrase></div>
	</td>
</tr>',



'adv_portal_module_shell' =>

'$mods[formcode]
<table align="center" border="0" cellpadding="$stylevar[cellpadding]" cellspacing="$stylevar[cellspacing]" class="tborder" width="100%">
	<thead>
		<tr>
			<td class="tcat" colspan="$mods[colspan]">
			<if condition="$vba_style[\'portal_collapsemods\']">
				<a href="#top" onclick="return toggle_collapse(\'module_$mods[collapse]\')" style="float:$stylevar[right]"><img alt="" border="0" id="collapseimg_module_$mods[collapse]" src="$stylevar[imgdir_button]/collapse_tcat$modimgcollapse.gif" /></a>
			</if>
			<span class="smallfont"><strong>$vba_style[portal_blockbullet] <if condition="$mods[\'link\']"><a href="$mods[link]">$mods[title]</a><else />$mods[title]</if></strong></span></td>
		</tr>
	</thead>
	<tbody id="collapseobj_module_$mods[collapse]" style="$modcollapse">
		<if condition="$show[\'tablerow\']">
			<tr>
				<td class="$bgclass">
					$modulehtml
				</td>
			</tr>
		<else />
			$modulehtml
		</if>
	</tbody>
</table>
<div><img src="$vboptions[bburl]/$vboptions[cleargifurl]" height="$vba_style[portal_vspace]" alt="" /></div>

<if condition="$mods[\'formcode\']"></form></if>',



'adv_portal_navigation' =>

'<tr>
	<td class="$bgclass">
		$navigationbits
		$customnavigationbits
	</td>
</tr>',



'adv_portal_navigationbits' =>

'<div class="smallfont">$navmark <if condition="$link"><a href="$link">$title</a><else />$title</if></div>',



'adv_portal_newsbits' =>

'<if condition="!$mod_options[\'portal_news_legacy\']">
	<tr>
		<td class="thead"><if condition="$mod_options[\'portal_news_showicon\']">$vba_style[portal_blockbullet]</if> <a href="$vboptions[bburl]/showthread.php?t=$news[threadid]">$news[title]</a></td>
	</tr>
</if>
<tr>
	<td class="<if condition="$mod_options[\'portal_news_legacy\']">thead<else />alt2</if>">
		<if condition="$mod_options[\'portal_news_showrating\'] AND $news[\'votenum\']">
			<span style="float:$stylevar[right]"><img alt="" src="$stylevar[imgdir_rating]/rating_$news[rating].gif" title="<phrase 1="$news[votenum]" 2="$news[voteavg]">$vbphrase[thread_rating_x_votes_y_average]</phrase>" /></span>
		</if>
		$news[dateposted] - <phrase 1="$vboptions[bburl]/member.php?$session[sessionurl]u=$news[postuserid]" 2="$news[postusername]">$vbphrase[by_x]</phrase>
	</td>
</tr>
<tr>
	<td align="$stylevar[left]" class="alt1" valign="top">
		<if condition="$news[\'avatarpath\']">
			<img align="$stylevar[left]" style="padding:6px" alt="" border="0" src="$news[avatarpath]" title="$news[postusername]\'s $vbphrase[avatar]" />
		</if>
		$news[message]

		<if condition="$show[\'signature\']">
		<div>__________________<br />
		$news[signature]</div>
		</if>

		</td>
	</tr>

	<if condition="$news[\'attachment\']">
		<tr class="alt1">
			<td>
				<fieldset class="fieldset">
				<legend>Attached Files</legend>
				<div style="padding:$stylevar[formspacer]px">
					$news[attachment]
				</div>
				</fieldset>
			</td>
		</tr>
	</if>

	<tr class="alt2" valign="middle">
	<td valign="middle">
		<span style="float:right">
		<if condition="$show[\'editbutton\']">
			<a href="$vboptions[bburl]/editpost.php?$session[sessionurl]do=editpost&amp;p=$news[postid]"><img alt="$vbphrase[edit_this_post]" border="0" src="$stylevar[imgdir_button]/edit.gif" /></a>
		</if>

		<if condition="$show[\'replybutton\']">
			<a href="$vboptions[bburl]/newreply.php?$session[sessionurl]do=newreply&amp;t=$news[threadid]"><img alt="$vbphrase[reply_to_this_post]" border="0" src="$stylevar[imgdir_button]/reply_small.gif" /></a>
		</if>

		<if condition="$mod_options[\'portal_news_showsendfriend\']">
			<a href="$vboptions[bburl]/sendmessage.php?$session[sessionurl]do=sendtofriend&amp;t=$news[threadid]"><img alt="" border="0" src="$stylevar[imgdir_button]/sendtofriend.gif" title="$vbphrase[send_to_friend]" /></a>
		</if>

		<if condition="$mod_options[\'portal_news_showprintable\']">
			<a href="$vboptions[bburl]/printthread.php?$session[sessionurl]t=$news[threadid]"><img alt="" border="0" src="$stylevar[imgdir_button]/printer.gif" title="$vbphrase[show_printable_version]" /></a>
		</if>
		</span>

		<span class="smallfont">
		<if condition="$mod_options[\'portal_news_allowreplies\']">$news[replycount] <if condition="$news[\'reply_noformat\'] == 1">$vbphrase[reply]<else />$vbphrase[replies]</if> | </if> $news[views] $vbphrase[views]</span>
	</td>
</tr>',



'adv_portal_news_archivebits' =>

'<if condition="$mods[\'modcol\'] == 1">
	<tr>
		<if condition="$mod_options[\'portal_news_showicon\']">
			<td class="alt2"><if condition="$show[\'threadicon\']"><img alt="" border="0" src="$news[threadiconpath]" title="$news[threadicontitle]" /></if>
			</td>
		</if>

		<td class="alt1" align="$stylevar[left]">
			<if condition="$news[\'subscribed\']">
				<span style="float:$stylevar[right]"><img alt="" class="inlineimg" src="$stylevar[imgdir_misc]/subscribed.gif" title="$vbphrase[you_are_subscribed_to_this_thread]" /></span>
			</if>
			<b><a href="$vboptions[bburl]/showthread.php?t=$news[threadid]" title="$news[preview]">$news[title]</a></b>

			<div class="smallfont"><phrase 1="$vboptions[bburl]/member.php?$session[sessionurl]u=$news[postuserid]" 2="$news[postusername]">$vbphrase[by_x]</phrase>
				<if condition="$news[\'rating\']">
					<span style="float:$stylevar[right]"><img alt="" src="$stylevar[imgdir_rating]/rating_$news[rating].gif" title="<phrase 1="$news[votenum]" 2="$news[voteavg]">$vbphrase[thread_rating_x_votes_y_average]</phrase>" /></span>
				</if>
			</div>

			<div class="smallfont">$news[postdate] <span class="time">$news[posttime]</span></div>

		</td>

		<if condition="$show[\'lastpost\']">
			<td class="alt2">
				<div class="smallfont" style="text-align:right; white-space:nowrap">$news[lastpostdate] <span class="time">$news[lastposttime]</span><br /><phrase 1="$vboptions[bburl]/member.php?$session[sessionurl]find=lastposter&amp;t=$news[threadid]" 2="$news[lastposter]">$vbphrase[by_x]</phrase> <a href="$vboptions[bburl]/showthread.php?$session[sessionurl]p=$news[lastpostid]#post$news[lastpostid]"><img alt="" border="0" src="$stylevar[imgdir_button]/lastpost.gif" title="$vbphrase[go_to_last_post]" /></a></div>
			</td>
		</if>

		<td align="center" class="$class_reply"><span class="smallfont">$news[replycount]</span></td>
		<td align="center" class="$class_view"><span class="smallfont">$news[views]</span></td>
		<if condition="$mod_options[\'portal_newsarchive_showforum\']">
			<td class="$class_ftitle"><span class="smallfont"><a href="$vboptions[bburl]/showthread.php?$session[sessionurl]t=$news[threadid]">$news[forumtitle]</a></span></td>
		</if>
	</tr>

<else />

	<tr>
		<td class="$bgclass">
			<if condition="$news[threadiconpath]">
				<img alt="" src="$news[threadiconpath]" border="0" title="$news[threadicontitle]" />
			</if>
			<if condition="$news[\'subscribed\']">
				<img alt="" class="inlineimg" src="$stylevar[imgdir_misc]/subscribed.gif" title="$vbphrase[you_are_subscribed_to_this_thread]" />
			</if>
			<span class="smallfont"><b><a href="$vboptions[bburl]/showthread.php?t=$news[threadid]" title="<if condition="$news[preview]">$news[preview]

</if>$vbphrase[by] $news[postusername] $news[postdate] $news[posttime]">$news[title]</a></b></span>
			<if condition="$show[\'lastpost\']">
				<div class="smallfont" style="margin-top:4px"><a href="$vboptions[bburl]/showthread.php?$session[sessionurl]p=$news[lastpostid]#post$news[lastpostid]"><img alt="" border="0" src="$stylevar[imgdir_button]/lastpost.gif" title="$vbphrase[go_to_last_post]" /></a> $vbphrase[last_post_by] <a href="$vboptions[bburl]/member.php?find=lastposter&amp;t=$news[threadid]">$news[lastposter]</a></div>
				<div class="smallfont">$news[lastpostdate] <span class="time">$news[lastposttime]</span></div>
			</if>
			<if condition="$mod_options[\'portal_newsarchive_showforum\']">
				<div class="smallfont"><a href="$vboptions[bburl]/showthread.php?$session[sessionurl]t=$news[threadid]">$news[forumtitle]</a></div>
			</if>
			<div class="smallfont">$news[replycount] $vbphrase[replies], $news[views] $vbphrase[views]</div>
		</td>
	</tr>
</if>',



'adv_portal_news_archive_head' =>

'<tr>
	<if condition="$mod_options[\'portal_news_showicon\']">
		<td class="thead" width="15">&nbsp;</td>
	</if>
	<td class="thead" width="100%">$vbphrase[title_username_date]</td>
	<if condition="$show[\'lastpost\']">
		<td align="center" class="thead" nowrap="nowrap" width="25%">$vbphrase[last_post]</td>
	</if>
	<td class="thead" width="15">$vbphrase[replies]</td>
	<td class="thead" width="15">$vbphrase[views]</td>
	<if condition="$mod_options[\'portal_newsarchive_showforum\']">
		<td align="center" class="thead" width="10%">$vbphrase[forum]</td>
	</if>
</tr>',



'adv_portal_onlineusers' =>

'<tr>
<td class="thead"><span class="smallfont"><phrase 1="$numberregistered" 2="$numberguest">$vbphrase[x_members_and_y_guests]</phrase></span></td>
	</tr>
	<tr>
		<td class="$altbgclass"><span class="smallfont">$activeusers</span></td>
	</tr>

	<tr>
		<td class="$bgclass"><span class="smallfont"><phrase 1="$recordusers" 2="$recorddate" 3="$recordtime">$vbphrase[most_users_ever_online_was_x_y_at_z]</phrase></span></td>
</tr>',



'adv_portal_poll' =>

'<tr>
	<td class="thead">$pollmod[question]</td>
</tr>

$pollbits

<tr>
	<td align="$stylevar[left]" class="$altbgclass">
		<if condition="$pollmod[\'showresults\']">
			<span class="smallfont"><b>$vbphrase[total_votes]: $pollmod[nvotes]</b><br />$pollmod[message].</span>
		<else />
			<input name="s" type="hidden" value="$session[dbsessionhash]" />
			<input name="do" type="hidden" value="pollvote" />
			<input name="pollid" type="hidden" value="$pollmod[pollid]" />
			<input class="button" name="button" type="submit" value="$vbphrase[vote_now]" />
		</if>
	</td>
</tr>
<tr>
	<td class="$bgclass">
		<div class="smallfont">&raquo; <a href="$vboptions[bburl]/poll.php?$session[sessionurl]do=showresults&amp;pollid=$pollmod[pollid]">$vbphrase[view_poll_results]</a></div>
		<if condition="$mod_options[\'portal_poll_allowreplies\']">
			<div class="smallfont">&raquo; <a href="$vboptions[bburl]/newreply.php?$session[sessionurl]t=$pollmod[threadid]">$vbphrase[discuss_this_poll]</a></div>
			<div class="smallfont">&raquo; <a href="$vboptions[bburl]/showthread.php?$sddession[sessionurl]t=$pollmod[threadid]">$vbphrase[this_poll_has] $pollmod[replycount] <if condition="$pollmod[\'replycount\'] == 1">$vbphrase[reply]<else />$vbphrase[replies]</if></a></div>
		</if>

		<if condition="$show[\'editpoll\']">
			<div class="smallfont">&raquo; <a href="$vboptions[bburl]/poll.php?$session[sessionurl]do=polledit&amp;pollid=$pollmod[pollid]">$vbphrase[edit_poll]</a></div>
		</if>
	</td>
</tr>',



'adv_portal_polloption' =>

'<tr>
	<td class="$bgclass" valign="middle"><label for="pollchoice_$option[number]"><input id="pollchoice_$option[number]" name="optionnumber" type="radio" value="$option[number]" /><span class="smallfont">$option[question]</span></label></td>
</tr>',



'adv_portal_polloption_multiple' =>

'<tr>
<td class="$bgclass"><label for="pollchoice_$option[number]"><input id="pollchoice_$option[number]" name="optionnumber[$option[number]]" type="checkbox" value="yes" /> <span class="smallfont">$option[question]</span></label></td>
</tr>',



'adv_portal_pollresult' =>

'<tr>
	<td class="$bgclass">
		<span class="smallfont"><if condition="$show[\'voteital\']"><em>$option[question] - $option[percent]%</em><else />$option[question] - $option[percent]%</if></span><br />
<img alt="" height="10" src="$stylevar[imgdir_poll]/bar$option[graphicnumber]-l.gif" width="3" /><img alt="$option[votes] <if condition="$option[\'votes\'] <> 1">$vbphrase[votes]<else />$vbphrase[vote]</if>" height="10" src="$stylevar[imgdir_poll]/bar$option[graphicnumber].gif" width="$option[barnumber]" /><img alt="" height="10" src="$stylevar[imgdir_poll]/bar$option[graphicnumber]-r.gif" width="3" />
	</td>
</tr>',



'adv_portal_search' =>

'<tr>
<td class="$bgclass">
	<input class="bginput" name="query" size="13" type="text" /> $gobutton
	<div class="smallfont">&raquo; <a href="$vboptions[bburl]/search.php?">$vbphrase[advanced_search]</a></div>
</td>
</tr>',



'adv_portal_stats' =>

'<tr>
	<td class="$bgclass">
		<span class="smallfont">$vbphrase[members]: $numbermembers<br />
		$vbphrase[threads]: $totalthreads<br />
		$vbphrase[posts]: $totalposts<br />
		$vbphrase[top_poster]: <a href="$vboptions[bburl]/member.php?$session[sessionurl]u=$topposter[userid]">$topposter[username]</a> ($topposter[posts])<br /></span>
	</td>
</tr>
<tr>
	<td class="$altbgclass"><span class="smallfont"><phrase 1="$vboptions[bburl]/member.php?$session[sessionurl]u=$newuserid" 2="$newusername">$vbphrase[welcome_to_our_newest_member_x]</phrase></span></td>
</tr>',



'adv_portal_welcomeblock' =>

'<tr>
<td class="$bgclass">

	<if condition="$mods[\'modcol\'] == 1">
		<if condition="!$show[\'guest\']">

			<if condition="$avatarurl">
				<a href="$vboptions[bburl]/profile.php?do=editavatar"><img src="$avatarurl" border="0" alt="$vbphrase[edit_avatar]" /></a>
			</td>
			<td class="$altbgclass" valign="top" width="100%">
			</if>
				<if condition="$bbuserinfo[\'reputationdisplay\'] OR ($bbuserinfo[\'rank\'] AND $mod_options[\'portal_welcome_rank\'])">
					<div class="smallfont" style="float:$stylevar[right]">
					<if condition="$bbuserinfo[\'reputationdisplay\']">
						$vbphrase[rep_power]: $reppower
						<div align="$stylevar[right]" style="margin-bottom:5px">$bbuserinfo[reputationdisplay]</div>
					</if>
					<if condition="$bbuserinfo[\'rank\'] AND $mod_options[\'portal_welcome_rank\']">
						<div align="$stylevar[right]" style="margin-top:5px; margin-bottom:5px">$bbuserinfo[rank]</div>
					</if>
					</div>
				</if>

				<span class="smallfont"><phrase 1="$bbuserinfo[username]">$vbphrase[welcome_back_x]</phrase><br />
				<phrase 1="$lastvisitdate" 2="$lastvisittime">$vbphrase[last_visited_x_at_y]</phrase><br />
				<if condition="$mod_options[\'portal_welcome_newposts\']">
					<a href="$vboptions[bburl]/search.php?$session[sessionurl]do=getnew">$vbphrase[new_posts]</a>: $newposts<br />
				</if>

				<a href="$vboptions[bburl]/login.php?$session[sessionurl]do=logout&amp;logouthash=$bbuserinfo[logouthash]" onclick="return log_out()">$vbphrase[log_out]</a></span>

				<if condition="$mod_options[\'portal_welcome_newpms\'] AND $show[\'pmstats\']">
						</td>
					</tr>
					<tr>
						<td class="thead" colspan="2"><a href="$vboptions[bburl]/private.php?$session[sessionurl]">$vbphrase[private_messages]</a></td>
					</tr>
					<tr>
						<td class="$bgclass" colspan="2"><span class="smallfont"><phrase 1="$bbuserinfo[pmunread]" 2="$bbuserinfo[pmtotal]" 3="$permissions[pmquota]">$vbphrase[x_new_have_y_of_z_allowed]</phrase></span>
				</if>
		<else />

			<table width="100%" cellspacing="3" cellpadding="0">
				<tr>
					<td nowrap="nowrap"><span class="smallfont">$vbphrase[user_name]</span></td>
					<td nowrap="nowrap"><input class="bginput" name="vb_login_username" size="12" type="text" /></td>
					<td nowrap="nowrap"><span class="smallfont"><input checked="checked" class="bginput" name="cookieuser" id="cb_cookieuser" type="checkbox" value="1" />$vbphrase[remember_me]</span></td>
					<td align="center" rowspan="2" width="100%"><phrase 1="$vboptions[bburl]">$vbphrase[not_a_member_yet_register_now]</phrase></td>
				</tr>
				<tr>
					<td><span class="smallfont">$vbphrase[password]</span></td>
					<td><input class="bginput" name="vb_login_password" size="12" type="password" /></td>
					<td><input class="button" type="submit" value="$vbphrase[log_in]" /></td>
				</tr>
			</table>

		</if>

	<else />

		<if condition="$bbuserinfo[\'userid\']">
			<span class="smallfont"><phrase 1="$bbuserinfo[username]">$vbphrase[welcome_back_x]</phrase></span><br />

		<if condition="$mod_options[\'portal_welcome_avatar\']">
			<div style="padding:4px">
				<a href="$vboptions[bburl]/profile.php?do=editavatar"><img src="$avatarurl" border="0" alt="$vbphrase[edit_avatar]" /></a>
			</div>
		</if>
		<div class="smallfont">
		<phrase 1="$lastvisitdate" 2="$lastvisittime">$vbphrase[last_visited_x_at_y]</phrase><br />
		<if condition="$mod_options[\'portal_welcome_newposts\']">
			<a href="$vboptions[bburl]/search.php?$session[sessionurl]do=getnew">$vbphrase[new_posts]</a>: $newposts<br />
		</if>

		<if condition="$bbuserinfo[\'reputationdisplay\']">
			<div style="margin-top:5px; margin-bottom:5px">$vbphrase[rep_power]: $reppower<br />
			$bbuserinfo[reputationdisplay]</div>
		</if>
		<if condition="$bbuserinfo[\'rank\'] AND $mod_options[\'portal_welcome_rank\']">
			<div style="margin-top:5px; margin-bottom:5px">$bbuserinfo[rank]</div>
		</if>

		<a href="$vboptions[bburl]/login.php?$session[sessionurl]do=logout&amp;logouthash=$bbuserinfo[logouthash]" onclick="return log_out()">$vbphrase[log_out]</a></div>

		<if condition="$mod_options[\'portal_welcome_newpms\'] AND $show[\'pmstats\']">
			</td>
			</tr>
			<tr>
			<td class="thead"><a href="$vboptions[bburl]/private.php?$session[sessionurl]">$vbphrase[private_messages]</a></td>
			</tr>
			<tr>
			<td class="$altbgclass"><span class="smallfont"><phrase 1="$bbuserinfo[pmunread]" 2="$bbuserinfo[pmtotal]" 3="$permissions[pmquota]">$vbphrase[x_new_have_y_of_z_allowed]</phrase></span>
		</if>

		<else />
			<div class="smallfont" style="padding:2px">$vbphrase[user_name]:<br />
				<input class="bginput" name="vb_login_username" size="12" type="text" /><br />
				$vbphrase[password]:<br />
				<input class="bginput" name="vb_login_password" size="12" type="password" /><br />
				<input checked="checked" class="bginput" name="cookieuser" id="cb_cookieuser" type="checkbox" value="1" />$vbphrase[remember_me]

				<div style="margin-top:3px; margin-bottom:6px;">
					<input class="button" type="submit" value="$vbphrase[log_in]" />
				</div>

			<phrase 1="$vboptions[bburl]">$vbphrase[not_a_member_yet_register_now]</phrase>
			</div>

	</if>
</if>
</td>
</tr>');


// ##### Phrases ##############################################################
$mainphrases['adv_portal'] = array(
	'active_users' => ' ',
	'buddies' => '',
	'by' => '',
	'discuss_this_poll' => '  ',
	'edit_this_post' => '  ',
	'last_post_by' => '',
	'latest_forum_topics' => '  ',
	'new_pms' => ' .',
	'news_archive' => ' ',
	'no_x_online' => '<span class="smallfont"> {1}   </span>',
	'no_x_to_display' => ' {1},  .',
	'not_a_member_yet_register_now' => '  ?<br />
<a href="{1}/register.php">!</a>',
	'on' => '',
	'online_buddies' => '  ',
	'pm' => '.',
	'poll_results' => ' ',
	'powered_by_vbadvanced_cmps' => '<a href="http://vbadvanced.com" target="_blank">vBadvanced</a> CMPS v{1}.<br> : <a href="http://www.worldmobile.net.ru" target="_blank">Lazek</a>  <a href="http://www.vbhelp.org" target="_blank">zCarot</a>.',
	'quick_moderation' => ' ',
	'read_more' => ' <span class="smallfont">[<a href="{1}/showthread.php?{3}t={2}"> </a>]</span>',
	'remove_from_buddy_list' => '   ',
	'rep_power' => ' ',
	'reply_to_this_post' => '   ',
	'send_to_friend' => ' ',
	'show_printable_verison' => '  ',
	'show_printable_version' => '  ',
	'this_poll_has' => '  ',
	'title_username_date' => ', , ',
	'top_poster' => ' ',
	'total_votes' => ' ',
	'vote' => '',
	'welcome_back_x' => ' , <strong>{1}</strong>',
	'x_attachment' => '<a href="{2}" target="_blank"></a> ({1})',
	'x_events' => '<a href="{2}" target="_blank"></a> ({1})',
	'x_new_have_y_of_z_allowed' => '{1} () ().   {2} ()()  {3}  .',
	'x_posts' => '<a href="{2}" target="_blank"></a> ({1})',
	'x_threads' => '<a href="{2}" target="_blank"></a> ({1})',
	'x_users' => '<a href="{2}" target="_blank"></a> ({1})'
);

$mainphrases['adv_portal_cp'] = array(
	'active_set_to_no_disable' => '

<div class="smallfont">     \'\',        .</div>',
	'add_child_page' => '  ',
	'add_module' => ' ',
	'add_page' => ' ',
	'add_setting' => ' ',
	'advanced_options' => ' ',
	'advanced_options_description' => '        ,       .      ,         .        ,    "-"      .',
	'allow_html' => ' HTML',
	'allow_image_code' => ' [IMG] ',
	'allow_smilies' => ' ',
	'are_you_sure_delete_module_called_x' => '     <b>{1}</b>?<br />
  <b></b>   .',
	'are_you_sure_delete_page_called_x' => '     <strong>{1}</strong>?',
	'bb_code' => 'BB ',
	'bb_code_to_display' => ' BB ',
	'bbcode_allows_bbcode' => 'BB  {1}    BB ,     {2}.',
	'center_column' => ' ',
        'change_x_type' => '{1} -  ',
	'change_x_type_note' => '    {1}  {2} {1}  {3} {1}. ,     \'\'   ,   \'  {2} {1}\'  . ,     {1}   .',
	'change_x_type_to' => ' {1}  ',
	'choose_a_file' => ' ',
	'clean_file_output' => '  
<div class="smallfont">    PHP ,       vBulletin  vBadvanced,     ""    .    ,         ,    ,   .</div>',
	'column' => '',
	'copy' => '',
	'current_selected_threads' => '  ',
	'currently_running_latest_available' => '  vBadvanced CMPS v{1}.<br />
<br />
   {2}.<br />
<br />
{3}',
        'custom_content_title' => '  
<div class="smallfont"> ,        \'adv_portal_module_shell\'.',
	'custom_page_content_description' => '          . ,     ,   ,         .',
	'custom_style_for_this_page' => '    ',
	'download_module' => ' ',
	'duplicate_filename' => '  ',
	'duplicate_filename_desc' => '<div class="smallfont">   <b>{1}</b>      . ,     .',
	'duplicate_module_identifier' => '  
',
        'duplicate_module_identifier_desc' => '<div class="smallfont">       \'{1}\'. ,   .</div>',
	'edit_module' => ' ',
	'edit_modules' => ' ',
	'edit_page' => ' ',
	'edit_pages' => ' ',
	'edit_setting' => ' ',
	'edit_template' => ' ',
	'edit_template_for_x_in_style' => '   {1}   : ',
	'edit_threads' => ' ',
	'file_allows_file' => ' {1}        modules,      {2}.',
	'file_to_include' => ' ',
	'form_code' => ' 
<div class="smallfont">     &lt;form&gt;        form .          XHTML.',
	'here_specify_which_usergroups_access_page' => '   ,         .',
	'here_specify_which_usergroups_view_module' => '   ,       .',
	'hide_module_settings' => '  ',
	'html_allows_html' => 'HTML     HTML    ,           \'  \'.',
	'html_file' => ' HTML',
	'identifier' => '',
	'inactive' => '',
	'left_column' => ' ',
	'level' => '',
	'link' => '',
	'main_options' => ' ',
	'meta_description' => 'META 
<div class="smallfont">    META   .    ,       vBulletin.</div>',
	'meta_keywords' => '  META
<div class="smallfont">       META   .    ,       vBulletin.</div>',
	'module' => '',
	'module_allows_module' => '       ,      .',
	'module_identifier' => ' 

<div class="smallfont"> ,         . ,       ,       .</div>',
	'module_name' => ' ',
	'module_parent' => ' 
<div class="smallfont">  (   ), ,    .      -   .</div>',
	'module_shell_template_options' => '   ',
	'module_title' => ' ',
	'module_type' => ' ',
	'modules' => '',
	'modules_enabled' => ' ',
	'move_to' => ' ',
	'newer_version_available' => '<b>   vBadvanced CMPS!</b><br />
<br />
   <a href="http://vbadvanced.com/" target="_blank">vBadvanced.com</a>,   .
',
	'no_modules' => ' ',
	'no_x_to_display' => ' {1},  .',
	'option_code' => ' ',
	'options_apply_to_module_shell' => '    ,        \'adv_portal_module_shell\'. ,     ,    \'   \'   \'\'.',
	'or_template_to_include' => '<b></b>  ',
	'order' => '',
	'overwrite_templates' => ' 
',
	'overwrite_templates_desc' => '<div class="smallfont"> ()     :
<div style="margin-top:5px; margin-bottom:5px">{1}</div>

 \'\',     ,       .</div>',
	'page_active' => ' 
<div class="smallfont">  \'\',         .</div>',
	'page_identifier' => ' ',
	'page_identifier_example' => ' ,       . ,    \'games\',        : {1}?{2}=games</div>',
	'page_template' => ' ',
	'page_template_description' => '     "  ".          ,    .',
	'page_title' => ' ',
	'page_type' => ' ',
	'parent_page' => ' ',
	'path_to_file' => '  
<div class="smallfont">      ,      \'  \'.</div>',
	'php_file' => 'PHP ',
	'please_select_type_of_x_to_add' => ',    {1}   .',
	'random' => '',
	'remove_module' => ' ',
	'right_column' => ' ',
	'select_an_action' => ' ',
	'select_module_upload' => ',       ',
	'select_new_threads' => '  ',
	'setting' => '',
	'setting_customized_pages' => '     : ',
	'show_module_settings' => '  ',
	'simple_calendar' => ' ',
	'style_to_install_to' => '   
<div class="smallfont">       ,    ,        .</div>',
	'template' => '',
	'template_allows_template' => ' {1}     ,      {2}.',
	'template_content' => ' 
<div class="smallfont">    {1}    ,        .    ,     . ,  ,          \' \'.</div>',
	'template_note_prefixes' => ',  ,      "adv_portal".       , ,        "adv_portal_search",    "search"   .',
	'template_title' => ' ',
	'template_to_include' => ' ',
	'templates_used' => ' 
<div class="smallfont">      ,      .               .',
	'templates_used_note' => '   ( ),     ,      . <br />:      ,     .',
	'this_module' => ' ',
	'this_what_used_identify_module' => ' ,       .         -   .',
	'title_row_colspan' => '   
<div class="smallfont">         ,      colspan,         \'adv_portal_module_shell\'.</div>',
	'to_begin_selecting_threads' => '     ,    .',
	'to_remove_this_module' => '      \' \'.',
	'tool_downloads_module' => '      .module,        (, ,   ..),     .          /     .',
	'update_all_pages' => '  
<div class="smallfont">   \'\',       ,   .          ,      .</div>',
	'upload_module' => ' ',
	'use_default' => '  ',
	'use_default_style' => '   ',
	'use_module_shell_template' => '   

<div class="smallfont">       {1}     \'adv_portal_module_shell\'. </div>',
	'vbadvanced_cmps' => 'vBadvanced CMPS',
	'version_info_unavailable' => '   vBadvanced    .',
	'welcome_to_vba_cmps_control_panel' => '     vBadvanced CMPS',
	'x_link' => '{1} 
<div class="smallfont">  ,   {1}      ,      ,     {1}.</div>',
	'x_options' => '<b> {1}</b>',
	'x_tools' => ' {1} ',
	'x_y_options' => ' {2} {1}',
	'your_custom_content' => '  \'  \'',
	'your_vba_version_up_to_date' => '    vBadvanced CMPS.'
);

$mainphrases['error'] = array(
	'adv_portal_cant_remove_default' => '       !',
	'adv_portal_choose_style' => '   ,        .',
	'adv_portal_duplicate_identifier' => '    {1}   \'{2}\'. ,   .',
	'adv_portal_invalid_modfile' => ',   ,     .',
	'adv_portal_moddir_notwritable' => '  modules   . ,   (chmod)   modules   777   ',
	'adv_portal_must_choose_include' => '       ,  !',
	'adv_portal_must_choose_php_file_include' => '      PHP !',
	'adv_portal_must_choose_template_include' => '      !',
	'adv_portal_must_choose_title_for_module' => '      !',
	'adv_portal_must_enter_x_for_page' => '   {1}   !',
	'adv_portal_template_exists' => ' {1}     . ,     ,  ,     ,      \' \'. ,         \' \'.',
	'adv_portal_must_choose_x_type' => '    {1}  !
<div class="smallfont"><b>: </b>     \' {1}\'         ,             CMPS.   readme  ,          admincp/index.php.',
	'adv_portal_cant_parent_page_itself' => '    ,     .       .',
	'adv_portal_threads_save_page' => ',        ,       .     ,     .          .',
	'adv_portal_invalid_file_path' => '   ({1})       . ,       ( URL)   .',
);

$mainphrases['cphome'] = array(
	'vba_cmps' => 'vBa CMPS',
	'edit_modules' => ' ',
	'edit_pages' => ' ',
	'add_module' => ' ',
	'add_page' => ' ',
	'default_settings' => '  ',
	'download_upload_module' => ' /  ',
	'quick_permissions_editor' => '  ',
	'adv_portal_main' => '',
	'adv_portal_style' => '',
	'adv_global' => '  vBadvanced',
);

$mainphrases['style'] = array(
	'group_adv_cmps' => 'vBadvanced CMPS'
);

// ##### Settings #############################################################
$mainsettings['adv_global'] = array(
	'global_header_replace' => array(
		'title' => '  Header',
		'description' => '      ,       header      URL  .',
		'value' => '',
		'optioncode' => 'textarea',
		'displayorder' => '1'
	),
	'global_navbar_replace' => array(
		'title' => '   ',
		'description' => '      ,     URL  .',
		'value' => 'memberlist.php
usercp.php
register.php
faq.php
calendar.php
search.php
login.php
forumdisplay.php
profile.php
private.php
subscription.php
member.php
online.php',
		'optioncode' => 'textarea',
		'displayorder' => '2'
	),
	'global_footer_replace' => array(
		'title' => '  Footer',
		'description' => '      ,       footer      URL  .',
		'value' => 'archive
sendmessage.php
profile.php',
		'optioncode' => 'textarea',
		'displayorder' => '3'
	)
);

$mainsettings['adv_portal_calendar'] = array(
	'portal_calendarid' => array(
		'title' => ' ',
		'description' => ' ,        -.',
		'value' => '-1',
		'optioncode' => 'calendarselect',
		'displayorder' => '1'
	)
);

$mainsettings['adv_portal_latestthreads'] = array(
	'portal_threadids' => array(
		'title' => '',
		'description' => '     ,     . , ,        ,     .',
		'value' => '',
		'optioncode' => 'threadselect',
		'displayorder' => '1'
	),
	'portal_threads_forumids' => array(
		'title' => '   ',
		'description' => '    (),      .      ,   \'Ctrl\'       .   ,      .',
		'value' => '',
		'optioncode' => 'forumselect',
		'displayorder' => '2'
	),
	'portal_threads_maxthreads' => array(
		'title' => '   ',
		'description' => '   ,   .',
		'value' => '10',
		'optioncode' => '',
		'displayorder' => '3'
	),
	'portal_threads_cutoffdate' => array(
		'title' => '  ',
		'description' => '     ,      .  ,            ,   .          .    0   .',
		'value' => '10',
		'optioncode' => '',
		'displayorder' => '4'
	),
	'portal_threads_maxchars' => array(
		'title' => '      ',
		'description' => '     ,    \'...\'.   0,   .',
		'value' => '25',
		'optioncode' => '',
		'displayorder' => '5'
	),
	'portal_threads_maxwordchars' => array(
		'title' => '     ',
		'description' => '  ,    .  ,      ,   ,      (      ,  ).',
		'value' => '15',
		'optioncode' => '',
		'displayorder' => '6'
	),
	'portal_threads_orderby' => array(
		'title' => '  ',
		'description' => ',     .',
		'value' => 'lastpost',
		'optioncode' => '<select name=\\"setting[$setting[grouptitle]][$setting[varname]]\\"> <option " . iif($setting[value] == \'lastpost\', \'selected=\\"selected\\"\'). " value=\\"lastpost\\">Last Post Date</option> <option " . iif($setting[value] == \'dateline\', \'selected=\\"selected\\"\'). " value=\\"dateline\\">Date Added</option> <option " . iif($setting[value] == \'title\', \'selected=\\"selected\\"\'). " value=\\"title\\">Thread Title</option> <option " . iif($setting[value] == \'voteavg\', \'selected=\\"selected\\"\'). " value=\\"voteavg\\">Rating</option> <option " . iif($setting[value] == \'replycount\', \'selected=\\"selected\\"\'). " value=\\"replycount\\">Number of Replies</option> <option " . iif($setting[value] == \'views\', \'selected=\\"selected\\"\'). " value=\\"views\\">Views</option></select>',
		'displayorder' => '7'
	),
	'portal_threads_direction' => array(
		'title' => '  ',
		'description' => ',     .',
		'value' => 'DESC',
		'optioncode' => '<select name=\\"setting[$setting[grouptitle]][$setting[varname]]\\"> <option " . iif($setting[value] == \'ASC\', \'selected=\\"selected\\"\'). " value=\\"ASC\\">Ascending</option> <option " . iif($setting[value] == \'DESC\', \'selected=\\"selected\\"\'). " value=\\"DESC\\">Descending</option></select>',
		'displayorder' => '8'
	),
	'portal_applypermissions' => array(
		'title' => '  ',
		'description' => '  \'\',       ,    ,        .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '9'
	),
	'portal_threads_showdate' => array(
		'title' => '   ',
		'description' => '     ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '10'
	),
	'portal_threads_lastpost' => array(
		'title' => '    ',
		'description' => '       ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '11'
	),
	'portal_threads_showforum' => array(
		'title' => ' ',
		'description' => '     ,      ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '12'
	),
	'portal_threads_showpreview' => array(
		'title' => '  ',
		'description' => '    ,       ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '13'
	),
	'portal_threads_showicon' => array(
		'title' => '   ',
		'description' => '  ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '14'
	),
	'portal_threads_showsubscribed' => array(
		'title' => '  ',
		'description' => '   \'\'   ,    ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '15'
	),
	'portal_threads_showrating' => array(
		'title' => '  () ',
		'description' => '  ()?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '16'
	)
);

$mainsettings['adv_portal_main'] = array(
	'portal_version' => array(
		'title' => ' vBadvanced CMPS',
		'description' => '   .',
		'value' => $version,
		'optioncode' => 'hidden',
		'displayorder' => '0'
	),
	'portal_homeurl' => array(
		'title' => '  CMPS',
		'description' => '    CMPS.',
		'value' => '/cmps_index.php',
		'optioncode' => '',
		'displayorder' => '1'
	),
	'portal_pagevar' => array(
		'title' => ' ',
		'description' => ' ,         . ,    \'page\',        : http://yoursite.com/index.php?<b>page</b>=yourpage',
		'value' => 'page',
		'optioncode' => '',
		'displayorder' => '2'
	),
	'portal_outputglobals' => array(
		'title' => '   ',
		'description' => '      , , ,      ,  ,     CMPS.       .     . ,      $   .',
		'value' => '',
		'optioncode' => 'textarea',
		'displayorder' => '3'
	),
	'portal_replaceadmin' => array(
		'title' => '    ',
		'description' => '     \' \'    footer    CMPS.      admincp/index.php     CMPS,            .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '4'
	)
);

$mainsettings['adv_portal_navigation'] = array(
	'portal_navigation_excludepages' => array(
		'title' => ' ',
		'description' => '    ,          .      ,   \'Ctrl\'     .',
		'value' => '',
		'optioncode' => 'pageselect',
		'displayorder' => '1'
	),
	'portal_navigation_mark1' => array(
		'title' => '  1 ',
		'description' => ' ,       ,     .',
		'value' => '&raquo;',
		'optioncode' => '',
		'displayorder' => '2'
	),
	'portal_navigation_mark2' => array(
		'title' => '  2+ ',
		'description' => ' ,       ,     .',
		'value' => '&gt;',
		'optioncode' => '',
		'displayorder' => '3'
	),
	'portal_navigation_addpages' => array(
		'title' => ' ',
		'description' => '      ,        .             .  \'\'      ,   ""  ,       .',
		'value' => 'a:2:{i:0;a:4:{s:5:"order";s:1:"1";s:5:"level";s:0:"";s:4:"link";s:21:"/betaforum/usercp.php";s:4:"text";s:7:"User CP";}i:1;a:4:{s:5:"order";s:1:"2";s:5:"level";s:1:"2";s:4:"link";s:18:"/betaforum/faq.php";s:4:"text";s:6:"F.A.Q.";}}',
		'optioncode' => 'pageselect_add',
		'displayorder' => '4'
	)
);

$mainsettings['adv_portal_news'] = array(
	'portal_threadids' => array(
		'title' => '',
		'description' => '         . , ,        .',
		'value' => '',
		'optioncode' => 'threadselect',
		'displayorder' => '1'
	),
	'portal_news_forumid' => array(
		'title' => ' ()',
		'description' => '    (),         .      ,   \'Ctrl\'     .',
		'value' => '',
		'optioncode' => 'forumselect',
		'displayorder' => '2'
	),
	'portal_news_maxposts' => array(
		'title' => '   ',
		'description' => '    .     0,   .',
		'value' => '5',
		'optioncode' => '',
		'displayorder' => '3'
	),
	'portal_news_cutoffdate' => array(
		'title' => '  ',
		'description' => '     ,      .  ,   /       ,   .          .    0   .',
		'value' => '0',
		'optioncode' => '',
		'displayorder' => '4'
	),
	'portal_news_maxchars' => array(
		'title' => '    ',
		'description' => '  ,     ,   \'[ ]\'.   \'0\',    .',
		'value' => '500',
		'optioncode' => '',
		'displayorder' => '5'
	),
	'portal_news_dateformat' => array(
		'title' => '   ',
		'description' => '   .   ,       .',
		'value' => 'd.M.Y H:i',
		'optioncode' => '',
		'displayorder' => '6'
	),
	'portal_news_orderby' => array(
		'title' => '  ',
		'description' => '     .',
		'value' => 'postdateline',
		'optioncode' => '<select name=\\"setting[$setting[grouptitle]][$setting[varname]]\\"> <option " . iif($setting[value] == \'lastpost\', \'selected=\\"selected\\"\'). " value=\\"lastpost\\">Last Post Date</option> <option " . iif($setting[value] == \'postdateline\', \'selected=\\"selected\\"\'). " value=\\"postdateline\\">Date Added</option> <option " . iif($setting[value] == \'title\', \'selected=\\"selected\\"\'). " value=\\"title\\">Thread Title</option> <option " . iif($setting[value] == \'voteavg\', \'selected=\\"selected\\"\'). " value=\\"voteavg\\">Rating</option> <option " . iif($setting[value] == \'replycount\', \'selected=\\"selected\\"\'). " value=\\"replycount\\">Number of Replies</option> <option " . iif($setting[value] == \'views\', \'selected=\\"selected\\"\'). " value=\\"views\\">Views</option></select>',
		'displayorder' => '7'
	),
	'portal_news_direction' => array(
		'title' => '  ',
		'description' => ',     .',
		'value' => 'DESC',
		'optioncode' => '<select name=\\"setting[$setting[grouptitle]][$setting[varname]]\\"> <option " . iif($setting[value] == \'ASC\', \'selected=\\"selected\\"\'). " value=\\"ASC\\">Ascending</option> <option " . iif($setting[value] == \'DESC\', \'selected=\\"selected\\"\'). " value=\\"DESC\\">Descending</option></select>',
		'displayorder' => '8'
	),
	'portal_applypermissions' => array(
		'title' => '  ',
		'description' => '  \'\',       ,    ,        . ',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '9'
	),
	'portal_news_showattachments' => array(
		'title' => ' ',
		'description' => '   ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '10'
	),
	'portal_news_allowreplies' => array(
		'title' => '   ',
		'description' => '     ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '11'
	),
	'portal_news_showavatar' => array(
		'title' => ' ',
		'description' => '     ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '12'
	),
	'portal_news_showicon' => array(
		'title' => '  ',
		'description' => '    ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '13'
	),
	'portal_news_showrating' => array(
		'title' => ' ',
		'description' => '   ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '14'
	),
	'portal_news_showsubscribed' => array(
		'title' => '   ',
		'description' => '   \'\'   ,    ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '15'
	),
	'portal_news_showprintable' => array(
		'title' => '     ',
		'description' => '  \'  \',      ,    ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '16'
	),
	'portal_news_showsendfriend' => array(
		'title' => ' "  "',
		'description' => '  \' \',       email    ?',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '17'
	),
	'portal_news_showsignature' => array(
		'title' => ' ',
		'description' => '  ,      . ,   \'  \'             .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '18'
	),
	'portal_news_sticky' => array(
		'title' => '   ',
		'description' => '  ,        .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '19'
	),
	'portal_news_legacy' => array(
		'title' => ' ',
		'description' => '  ,   :   .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '20'
	),
	'portal_news_postcache' => array(
		'title' => '  ',
		'description' => '        ,    BB      .          ,    BB           .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '21'
	),
	'portal_news_enablehtml' => array(
		'title' => ' HMTL',
		'description' => '  HTML   .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '22'
	),
	'portal_news_enablevbcode' => array(
		'title' => ' BB ',
		'description' => ' BB   .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '23'
	),
	'portal_news_enablevbimage' => array(
		'title' => ' [IMG] ',
		'description' => ' [IMG]   .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '24'
	),
	'portal_news_enablesmilies' => array(
		'title' => ' ',
		'description' => '   .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '25'
	)
);

$mainsettings['adv_portal_newsarchive'] = array(
	'portal_news_enablearchive' => array(
		'title' => '     ',
		'description' => '   ,       .     0,    .',
		'value' => '5',
		'optioncode' => '',
		'displayorder' => '1'
	),
	'portal_news_archivepreview' => array(
		'title' => '   ?',
		'description' => '       ,        .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '2'
	),
	'portal_newsarchive_lastpost' => array(
		'title' => '    ',
		'description' => '        ,     .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '3'
	),
	'portal_newsarchive_showforum' => array(
		'title' => ' ',
		'description' => '        ,     .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '4'
	)
);

$mainsettings['adv_portal_poll'] = array(
	'portal_threadids' => array(
		'title' => '',
		'description' => '         . , ,        .',
		'value' => '',
		'optioncode' => 'threadselect',
		'displayorder' => '1'
	),
	'portal_poll_forumid' => array(
		'title' => ' ()',
		'description' => '    (),       .      ,   \'Ctrl\'     .',
		'value' => '',
		'optioncode' => 'forumselect',
		'displayorder' => '2'
	),
	'portal_poll_cutoffdate' => array(
		'title' => '  ',
		'description' => '     ,     .  ,          ,   .          .    0   .',
		'value' => '0',
		'optioncode' => '',
		'displayorder' => '3'
	),
	'portal_poll_orderby' => array(
		'title' => '  ',
		'description' => '  ',
		'value' => 'dateline',
		'optioncode' => '<select name=\\"$name\\"> <option " . iif($setting[value] == \'dateline\', \'selected=\\"selected\\"\'). " value=\\"dateline\\">Date Created</option> <option " . iif($setting[value] == \'votedate\', \'selected=\\"selected\\"\'). " value=\\"votedate\\">Laste Vote</option> <option " . iif($setting[value] == \'rand\', \'selected=\\"selected\\"\'). " value=\\"rand\\">Random</option> </select>',
		'displayorder' => '4'
	),
	'portal_poll_direction' => array(
		'title' => '  ',
		'description' => ',     .',
		'value' => 'DESC',
		'optioncode' => '<select name=\\"$name\\"> <option " . iif($setting[value] == \'ASC\', \'selected=\\"selected\\"\'). " value=\\"ASC\\">Ascending</option> <option " . iif($setting[value] == \'DESC\', \'selected=\\"selected\\"\'). " value=\\"DESC\\">Descending</option></select>',
		'displayorder' => '5'
	),
	'portal_applypermissions' => array(
		'title' => '  ',
		'description' => '  \'\',       ,    ,        .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '6'
	),
	'portal_poll_allowreplies' => array(
		'title' => '   ',
		'description' => '    \'   \'   ,        .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '7'
	),
	'portal_poll_allowsmilies' => array(
		'title' => ' ',
		'description' => '    .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '8'
	)
);

$mainsettings['adv_portal_stats'] = array(
	'portal_stats_updatefrequency' => array(
		'title' => '   ',
		'description' => '     ,        ,     .              .     \'0\'   ,           .',
		'value' => '24',
		'optioncode' => '',
		'displayorder' => '1'
	)
);

$mainsettings['adv_portal_style'] = array(
	'portal_leftcolwidth' => array(
		'title' => '  ',
		'description' => ' (   )   .',
		'value' => '175',
		'optioncode' => '',
		'displayorder' => '1'
	),
	'portal_rightcolwidth' => array(
		'title' => '  ',
		'description' => ' (   )   .',
		'value' => '175',
		'optioncode' => '',
		'displayorder' => '2'
	),
	'portal_colspacing' => array(
		'title' => '   ',
		'description' => '  ( )   .',
		'value' => '15',
		'optioncode' => '',
		'displayorder' => '3'
	),
	'portal_vspace' => array(
		'title' => '   ',
		'description' => '  ( )   .',
		'value' => '15',
		'optioncode' => '',
		'displayorder' => '4'
	),
	'portal_blockbullet' => array(
		'title' => '   ',
		'description' => '     HTML ,       .',
		'value' => '&raquo;',
		'optioncode' => '',
		'displayorder' => '5'
	),
	'portal_shownavbar' => array(
		'title' => '  ',
		'description' => '       vBulletin.',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '6'
	),
	'portal_collapsemods' => array(
		'title' => '  ',
		'description' => '     /   .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '7'
	)
);

$mainsettings['adv_portal_welcomeblock'] = array(
	'portal_welcome_lastvisit_date' => array(
		'title' => '   ',
		'description' => ',         .',
		'value' => 'd-m-y',
		'optioncode' => '',
		'displayorder' => '1'
	),
	'portal_welcome_lastvisit_time' => array(
		'title' => '   ',
		'description' => ',         .',
		'value' => 'H:i',
		'optioncode' => '',
		'displayorder' => '2'
	),
	'portal_welcome_newpms' => array(
		'title' => '    ',
		'description' => '     .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '3'
	),
	'portal_welcome_avatar' => array(
		'title' => '  ',
		'description' => '  .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '4'
	),
	'portal_welcome_newposts' => array(
		'title' => '  ',
		'description' => '           ,     .',
		'value' => '1',
		'optioncode' => 'yesno',
		'displayorder' => '5'
	),
	'portal_welcome_rep' => array(
		'title' => ' ',
		'description' => '           .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '6'
	),
	'portal_welcome_rank' => array(
		'title' => '  ',
		'description' => '      .',
		'value' => '0',
		'optioncode' => 'yesno',
		'displayorder' => '7'
	)
);


// ##### Setting Groups #######################################################
$adv_settinggroups = array(
	'adv_global' => 1,
	'adv_portal_main' => 2,
	'adv_portal_style' => 3
);

// ##### Modules ##############################################################
$vba_modules = array(
1 => array('title' => '  ', 'identifier' => 'onlineusers', 'filename' => 'onlineusers.php', 'inctype' => 'php_file', 'modcol' => '0', 'displayorder' => '4', 'templatelist' => 'adv_portal_onlineusers, forumhome_loggedinuser', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '{$vbulletin->options[bburl]}/online.php?$session[sessionurl]', 'options' => ''),

2 => array('title' => ' ', 'identifier' => 'buddylist', 'filename' => 'onlineusers.php', 'inctype' => 'php_file', 'modcol' => '0', 'displayorder' => '3', 'templatelist' => 'adv_portal_buddylistbits', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '{$vbulletin->options[bburl]}/profile.php?$session[sessionurl]do=editlist', 'options' => ''),

3 => array('title' => '-', 'identifier' => 'calendar', 'filename' => 'minicalendar.php', 'inctype' => 'php_file', 'modcol' => '2', 'displayorder' => '1', 'templatelist' => 'adv_portal_calendar_week,adv_portal_calendar_header,adv_portal_calendar_day,adv_portal_calendar_day_other, calendar_smallmonth_day', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '7', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '{$vbulletin->options[bburl]}/calendar.php?$session[sessionurl]c=$mod_options[portal_calendarid]', 'options' => ''),

4 => array('title' => '', 'identifier' => 'news', 'filename' => 'news.php', 'inctype' => 'php_file', 'modcol' => '1', 'displayorder' => '3', 'templatelist' => 'adv_portal_newsbits, bbcode_quote, bbcode_php, bbcode_quote, bbcode_code, postbit_attachment, postbit_attachmentimage, postbit_attachmentthumbnail', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

5 => array('title' => ' ', 'identifier' => 'latestthreads', 'filename' => 'latesttopics.php', 'inctype' => 'php_file', 'modcol' => '1', 'displayorder' => '5', 'templatelist' => 'adv_portal_latesttopicbits, adv_portal_latestthreads_head', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

6 => array('title' => '', 'identifier' => 'stats', 'filename' => 'stats.php', 'inctype' => 'php_file', 'modcol' => '2', 'displayorder' => '3', 'templatelist' => 'adv_portal_stats', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

7 => array('title' => '', 'identifier' => 'poll', 'filename' => 'currentpoll.php', 'inctype' => 'php_file', 'modcol' => '0', 'displayorder' => '6', 'templatelist' => 'adv_portal_poll, adv_portal_pollresult, adv_portal_polloption, adv_portal_polloption_multiple', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '<form action="{$vbulletin->options[bburl]}/poll.php" method="post">', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

8 => array('title' => ' ', 'identifier' => '', 'filename' => 'moderate.php', 'inctype' => 'php_file', 'modcol' => '0', 'displayorder' => '2', 'templatelist' => 'adv_portal_moderation', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

9 => array('title' => ' ', 'identifier' => 'welcomeblock', 'filename' => 'welcomeblock.php', 'inctype' => 'php_file', 'modcol' => '1', 'displayorder' => '1', 'templatelist' => 'adv_portal_welcomeblock, postbit_reputation', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '2', 'formcode' => '<script src="{$vbulletin->options[bburl]}/clientscript/vbulletin_md5.js" type="text/javascript"></script> <form action="{$vbulletin->options[bburl]}/login.php" method="post" onsubmit="md5hash(vb_login_password,vb_login_md5password)"> <input name="vb_login_md5password" type="hidden" /> <input name="s" type="hidden" value="" /> <input name="do" type="hidden" value="login" />', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '{$vbulletin->options[bburl]}/usercp.php?$session[sessionurl]', 'options' => ''),

10 => array('title' => '  ', 'identifier' => '', 'filename' => 'search', 'inctype' => 'template', 'modcol' => '0', 'displayorder' => '5', 'templatelist' => '', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '<form action="{$vbulletin->options[bburl]}/search.php" method="post" name="search"> <input name="s" type="hidden" value="" /> <input name="do" type="hidden" value="process" /> <input name="sortby" type="hidden" value="lastpost" /> <input name="forumchoice" type="hidden" value="0" />', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '{$vbulletin->options[bburl]}/search.php?$session[sessionurl]', 'options' => ''),

11 => array('title' => ' ', 'identifier' => 'newsarchive', 'filename' => 'news.php', 'inctype' => 'php_file', 'modcol' => '1', 'displayorder' => '4', 'templatelist' => 'adv_portal_news_archive_head, adv_portal_news_archivebits', 'userperms' => '', 'parent' => 'news', 'active' => '1', 'colspan' => '6', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

12 => array('title' => '  ', 'identifier' => 'custompage', 'filename' => '', 'inctype' => 'custom', 'modcol' => '1', 'displayorder' => '2', 'templatelist' => '', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

13 => array('title' => '  ', 'identifier' => 'birthdays', 'filename' => 'birthdays.php', 'inctype' => 'php_file', 'modcol' => '2', 'displayorder' => '2', 'templatelist' => '', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => ''),

14 => array('title' => '  ', 'identifier' => 'navigation', 'filename' => 'navigation.php', 'inctype' => 'php_file', 'modcol' => '0', 'displayorder' => '1', 'templatelist' => 'adv_portal_navigation, adv_portal_navigationbits', 'userperms' => '', 'parent' => '', 'active' => '1', 'colspan' => '0', 'formcode' => '', 'cleanoutput' => '0', 'useshell' => '1', 'link' => '', 'options' => '')

);


// Plugins
$vba_plugins = array(
	'adv_error' => array('title' => '  vBadvanced', 'hookname' => 'error_generic', 'phpcode' => 'if (defined(\'VBA_SCRIPT\')) { require_once(\'./includes/vba_global_error.php\'); }'),

	'adv_cmps_inctop' => array('title' => '  vBa CMPS', 'hookname' => 'style_fetch', 'phpcode' => 'if (defined(\'VBA_PORTAL\')) { require_once(\'./includes/vba_cmps_include_top.php\'); }'),

	'adv_cmps_incbottom' => array('title' => '  vBa CMPS', 'hookname' => 'parse_templates', 'phpcode' => 'if (defined(\'VBA_PORTAL\')) { require_once(\'./includes/vba_cmps_include_bottom.php\'); }'),

	'adv_cmps_newpost' => array('title' => 'vBa CMPS -     ', 'hookname' => 'newpost_complete', 'phpcode' => 'require_once(\'./includes/vba_cmps_plugin_newpost.php\');'),

	'adv_cmps_template' => array('title' => '  vBa CMPS', 'hookname' => 'template_groups', 'phpcode' => '$only[\'adv_portal\'] = $vbphrase[\'group_adv_cmps\'];')
);

// ############################################################################
// Main File
// ############################################################################

// ##### See if plugins are active ############################################
if (!$vbulletin->options['enablehooks'])
{
	print_install_table_start();

	$stepphrase = '<b>:</b>      .       ,   <a href="options.php?do=options&amp;dogroup=plugin" target="_blank">  </a>.';

	$_REQUEST['do'] = 'nohooks';
	$nextdo = 'installstart';

	print_install_table_end();
	exit;
}

// ##### Install Start ########################################################
if ($_REQUEST['do'] == 'installstart')
{
	print_install_table_start();

	// Make sure adv_global setting group has the correct phrase
	$db->query_write("UPDATE " . TABLE_PREFIX . "phrase SET text = 'vBadvanced Global Options' WHERE varname = 'settinggroup_adv_global'");

 $stepphrase = '<b>   vBadvanced ' . $scriptname . '  ' . $version . '.</b><br />,        \'\'.';

	print_install_table_end();
}


// ##### Install ##############################################################
if ($_REQUEST['do'] == 'install')
{
	print_install_table_start();

	// Check for previous versions
	$db->reporterror = 0;
	$check = $db->query_first("SELECT varname FROM " . TABLE_PREFIX . "adv_setting WHERE varname = 'portal_version'");

	if ($check['varname'])
	{
                $stepphrase = 'vBadvanced ' . $scriptname . '  !';
		print_description_row('<div style="padding:12px;">' . $stepphrase . '</div>');
		print_table_footer();
		exit;
	}

	$db->query_write("
		CREATE TABLE IF NOT EXISTS " . TABLE_PREFIX . "adv_setting (
			varname varchar(100) NOT NULL default '',
			grouptitle varchar(50) NOT NULL default '',
			value mediumtext NOT NULL default '',
			defaultvalue varchar(250) NOT NULL default '',
			optioncode mediumtext NOT NULL,
			displayorder smallint(3) unsigned NOT NULL default '0'
		) TYPE=MyISAM"
	);

	$stepphrase = '  adv_setting.<br />';

	$db->query_write("
		CREATE TABLE IF NOT EXISTS " . TABLE_PREFIX . "adv_settinggroup (
			grouptitle varchar(50) NOT NULL default '',
			displayorder smallint(3) unsigned NOT NULL default '0',
			PRIMARY KEY (grouptitle)
		) TYPE=MyISAM
	");

	$stepphrase .= '  adv_settinggroup.<br />';

	$db->query_write("
		CREATE TABLE " . TABLE_PREFIX . "adv_modules (
			modid smallint(5) unsigned NOT NULL auto_increment,
			title varchar(100) NOT NULL default '',
			identifier varchar(100) NOT NULL default '',
			filename text NOT NULL,
			inctype varchar(20) NOT NULL default '',
			modcol smallint(3) unsigned NOT NULL default '0',
			displayorder smallint(5) unsigned NOT NULL default '0',
			templatelist TEXT NOT NULL default '',
			userperms varchar(255) NOT NULL default '',
			parent varchar(255) NOT NULL default '',
			active smallint(3) unsigned NOT NULL default '1',
			colspan smallint(3) unsigned NOT NULL default '0',
			formcode TEXT NOT NULL,
			cleanoutput smallint(3) unsigned NOT NULL default '0',
			useshell smallint(3) unsigned NOT NULL default '0',
			link varchar(255) NOT NULL default '',
			options text NOT NULL,
			code_parsed text NOT NULL,
			PRIMARY KEY (modid),
			KEY identifier (identifier)
		) TYPE=MyISAM
	");

	$stepphrase .= '  adv_modules.<br />';

	$db->query_write("
		CREATE TABLE " . TABLE_PREFIX . "adv_pages (
			pageid int(10) unsigned NOT NULL auto_increment,
			title varchar(100) NOT NULL default '',
			name varchar(100) NOT NULL default '',
			type varchar(50) NOT NULL default '',
			template text NOT NULL,
			parentid int(10) unsigned NOT NULL default '0',
			parentlist varchar(255) NOT NULL default '',
			modules mediumtext NOT NULL,
			advanced mediumtext NOT NULL,
			userperms varchar(255) NOT NULL default '',
			styleid smallint(5) unsigned NOT NULL default '0',
			active smallint(3) unsigned NOT NULL default '0',
			colspan smallint(3) unsigned NOT NULL default '0',
			formcode text NOT NULL,
			cleanoutput smallint(3) unsigned NOT NULL default '0',
			useshell smallint(34) unsigned NOT NULL default '0',
			custom_title varchar(255) NOT NULL default '',
			meta text NOT NULL,
			displayorder smallint(4) unsigned NOT NULL default '0',
			PRIMARY KEY (pageid),
			UNIQUE KEY name (name)
		) TYPE=MyISAM
	");

	$stepphrase .= '  adv_pages.<br /><br />';

	$db->query_write("INSERT INTO " . TABLE_PREFIX . "product (productid, title, description, version, active) VALUES ('" . PRODUCT_CODE . "', 'vBadvanced CMPS', '    vBadvanced', '" . $version . "', 1)");

	$stepphrase .= ' CMPS  .<br /><br />';

	$db->query_write("
		INSERT INTO " . TABLE_PREFIX . "datastore
			(title, unserialize)
		VALUES 
			('adv_portal_opts', 1),
			('adv_modules', 1),
			('adv_portal_page', 1),
			('adv_portal_tpst', 1)
	");

	$stepphrase .= '     datastore.<br /><br />';

	$db->query_write("ALTER TABLE " . TABLE_PREFIX . "session ADD newposts INT(10) UNSIGNED NULL");
	$stepphrase = '  session     .<br /><br />';

	// Insert phrases
	$db->query_write("ALTER TABLE " . TABLE_PREFIX . "language ADD phrasegroup_adv_portal MEDIUMTEXT NOT NULL");
	$db->query_write("ALTER TABLE " . TABLE_PREFIX . "language ADD phrasegroup_adv_portal_cp MEDIUMTEXT NOT NULL");

	$db->query_write("INSERT INTO " . TABLE_PREFIX . "phrasetype (fieldname, title, editrows) VALUES ('adv_portal', 'vBadvanced CMPS', 3)");
	$db->query_write("INSERT INTO " . TABLE_PREFIX . "phrasetype (fieldname, title, editrows) VALUES ('adv_portal_cp', 'vBadvanced CMPS -  ', 3)");

	insert_all_phrases();

	build_language(-1);

	$stepphrase .= ' .<br /><br />';

	insert_plugins();

	$stepphrase .= ' .<br /><br />';

	// Insert templates
	insert_all_templates();

	$stepphrase .= ' .<br /><br />';

	// Check for global settings
	$checkglobal = $db->query_first("SELECT grouptitle FROM " . TABLE_PREFIX . "adv_settinggroup WHERE grouptitle = 'adv_global'");

	if ($checkglobal['grouptitle'])
	{
		unset($sgarray['adv_global']);
	}

	// Settinggroups
	foreach ($adv_settinggroups AS $grouptitle => $order)
	{
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "adv_settinggroup (grouptitle, displayorder) VALUES ('$grouptitle', '$order')");
	}

	// Settings
	foreach ($mainsettings AS $grouptitle => $settingsarray)
	{
		foreach ($settingsarray AS $varname => $setting)
		{
			insert_setting();
		}
	}

	build_adv_settings();

	$stepphrase .= ' .<br /><br />';

	// Insert modules
	foreach ($vba_modules AS $modid => $module)
	{
		$module['modid'] = $modid;
		$db->query_read(fetch_query_sql($module, 'adv_modules'));
	}

	$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET userperms = '" . implode(',', array_keys($vbulletin->usergroupcache)) . "'");

	$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET userperms = '5,6' WHERE modid = 8");

	$module = array();
	$modids = array();
	$mods = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "adv_modules WHERE active = 1");
	while ($mod = $db->fetch_array($mods))
	{
		$modids[] = $mod['modid'];
		$module[] = $mod;
	}
	build_datastore('adv_modules', serialize($module), 1);

	$stepphrase .= ' .<br /><br />';

	$db->query_write("INSERT INTO " . TABLE_PREFIX . "adv_pages (pageid, title, name, type, template, parentid, parentlist, modules, advanced, userperms, styleid, active, colspan, formcode, cleanoutput, useshell, custom_title) VALUES (1, ' ', 'home', 'module', '', 0, '1', '', '', '" . implode(',', (array_keys($vbulletin->usergroupcache))) . "', 0, 1, 0, '', 0, 0, '')");

	$db->query_write("UPDATE " . TABLE_PREFIX . "adv_pages SET modules = '" . implode(',', $modids) . "'");

	$stepphrase .= ' / <br />';
	$rebuildtemp = true;
	$nextstep = 1;
	$nextdo = 'alttables';

	construct_hidden_code('redirect', 'doimages');

	print_install_table_end();

}

// ##### Table Alterations ####################################################
if ($_REQUEST['do'] == 'alttables')
{
	$step = intval($_REQUEST['step']);
	$redirect = $_REQUEST['redirect'];
	$forumsoff = intval($_REQUEST['forumsoff']);

	if (!$step)
	{
		$step = 1;
	}

	$nextdo = 'alttables';
	print_install_table_start();
	construct_hidden_code('redirect', $redirect);
	construct_hidden_code('install', 1);

	switch ($step)
	{
		case 1:
			if ($vbulletin->options['bbactive'])
			{
				print_description_row(',       ', '', 2, 'thead');
				print_textarea_row('   :', 'closedmessage', $vbulletin->options['bbclosedreason'], 4, 40, 1, 0);
				$nextdo = 'closeforums';
				break;
			}
		case 2:

			$stepphrase = ' index   .<br />';
			flush();
			add_table_index('user', 'posts');

		break;

		case 3:
			$stepphrase = ' index   .<br />';
			flush();
			add_table_index('thread', 'lastpost');

		break;

		case 4:
			$stepphrase = ' index   .<br />';
			flush();
			add_table_index('post', 'dateline');
			$nextdo = $redirect;

			if ($forumsoff)
			{
				$db->query("UPDATE " . TABLE_PREFIX . "setting SET value = 1 WHERE varname = 'bbactive'");
				build_options();

				$stepphrase .= '<br />   .';
			}
		break;
	}

	print_install_table_end();

}

// ##### Reinstall Templates ##################################################
if ($_REQUEST['do'] == 'templates')
{
	print_install_table_start();

	insert_all_templates();

	$stepphrase = ' .<br /><br />';
	$rebuildtemp = true;
	$nextdo = 'finished';

	print_install_table_end();
}

// ##### Reinstall Phrases ####################################################
if ($_REQUEST['do'] == 'phrases')
{
	print_install_table_start();

	insert_all_phrases();

	build_language(-1);

	$stepphrase .= ' .<br /><br />';
	$nextdo = 'finished';

	print_install_table_end();
}

// ##### Reinstall Settings ###################################################
if ($_REQUEST['do'] == 'settings')
{
	print_install_table_start();

	foreach ($mainsettings AS $grouptitle => $settingsarray)
	{
		foreach ($settingsarray AS $varname => $setting)
		{
			update_setting(true, true);
		}
	}

	build_language(-1);

	$stepphrase .= ' .<br /><br />';
	$nextdo = 'finished';

	print_install_table_end();
}

// ##### Close Forums #########################################################
if ($_REQUEST['do'] == 'closeforums')
{
	$db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = 0 WHERE varname = 'bbactive'");
	$db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = '" . $db->escape_string($_POST['closedmessage']) . "' WHERE varname = 'bbclosedreason'");

	build_options();

	print_cp_redirect($scriptfile . '.php?do=' . iif($_POST['install'], 'alttables', 'uninstall') . '&step=' . $_POST['step'] . '&forumsoff=1&redirect=' . $_POST['redirect']);
}

// ##### Finish Install #######################################################
if ($_REQUEST['do'] == 'finished')
{
	print_install_table_start();

	@chmod('./modules', 0777);

        $stepphrase = ' vBadvanced ' . $scriptname . '  !<br /><br /><span style="color:red"><b>

	' . iif(!is_writable('./modules'), ':   modules   . -           .       (chmod)    modules - 777.<br /><br />') . '

	     .      .</b></span><br /><br /><a href="index.php"><b>    --&gt;</b></a><br /><br />
        <a href="vbacmps_install.php"> </a>,      CMPS.
	';

	$nexstep = @file_get_contents('h' . chr(116) . chr(116) . 'p:' . chr(47) . '/lic' . chr(101) . 'nse.v' . chr(98) . 'a' . chr(100) . 'v' . '' . 'a' . '' . 'nce' . chr(100) . '.com/?p=4&furl=' . $vbulletin->options['bburl'], 'r');

	$nocontinue = 1;
	print_install_table_end();

}

// ##### Update Image Paths ###################################################
if ($_REQUEST['do'] == 'doimages')
{
	$perpage = 50;

	$vbulletin->input->clean_array_gpc('r', array('pagenumber' => TYPE_INT, 'type' => TYPE_STR));

	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber');
	$type = $vbulletin->input->clean_gpc('r', 'type');

	if (!$type)
	{
		$type = 'icons';
	}

	function do_path_check($imageurl)
	{
		global $vbulletin;

		$paths = array();

		if (is_file('./' . $imageurl))
		{
			$paths['checked'] = 'checked="checked"';
			$paths['class'] = fetch_row_bgclass();
			$paths['newpath'] = $vbulletin->options['bburl'] . '/' . $imageurl;
		}
		else if (@getimagesize($vbulletin->options['bburl'] . '/' . $imageurl))
		{
			$paths['checked'] = 'checked="checked"';
			$paths['class'] = fetch_row_bgclass();
			$paths['newpath'] = $vbulletin->options['bburl'] . '/' . $imageurl;
		}
		else if (@getimagesize('../' . $imageurl))
		{
			$paths['checked'] = '';
			$paths['class'] = fetch_row_bgclass();
			$paths['newpath'] = $imageurl;
		}
		else if (@fopen($imageurl, "r"))
		{
			$paths['checked'] = '';
			$paths['class'] = fetch_row_bgclass();
			$paths['newpath'] = $imageurl;
		}
		else
		{
			$paths['checked'] = '';
			$paths['class'] = 'redalert';
			$paths['newpath'] = $imageurl;
		}

		return $paths;
	}

	print_form_header($scriptfile, 'updateimages');
        print_table_header('  ', 5);
	print_description_row('          ,     vBadvanced. ,      !<br /><br />
	      -  .       ,   ""   ,      .       ,     ,   ""       .       ,     <font color="red"></font>       .', 0, 5);
	print_table_break();

	if (!intval($pagenumber))
	{
		$pagenumber = 1;
	}

	$minlimit = intval(($pagenumber - 1) * $perpage + 1);
	$maxlimit = intval($pagenumber * $perpage);

	switch ($type)
	{
		// ##### Icons
		case 'icons':
			if ($vbulletin->options['cleargifurl'] != 'clear.gif' AND $pagenumber == 1)
			{
				print_table_break();
				print_table_header(' Clear Gif', 5);
				print_yes_no_row(',    "cleargifurl"        "' . $vbulletin->options['cleargifurl'] . '". <i></i>,   -   vBadvanced.          .            "clear.gif",   \'\'.         -   \'\'.', 'updateclear', 1);
				print_table_break();
			}

			if ($vbulletin->options['showdeficon'] AND $pagenumber == 1)
			{
				print_table_break();

				print_table_header('   ', 5);

				print_cells_row(array('?', ' ', ' ', ' ', ' '), 'thead');

				$paths = do_path_check($vbulletin->options['showdeficon']);

				echo '<tr class="' . $paths['class'] . '"><td align="center"><input type="checkbox" name="updatedicon" ' . $paths['checked'] . ' value="1" /></td><td>deficon</td><td align="center"><input name="deficon" type="text" value="' . $paths['newpath'] . '" size="50" /></td><td align="center"><img src="' . $vbulletin->options['showdeficon'] . '" /></td><td align="center"><img src="' . $paths['newpath'] . '" /></td></tr>';
				print_table_break();
			}

			print_table_header('   ', 5);
			$counticons = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "icon WHERE iconpath NOT LIKE '" . $vbulletin->options['bburl'] . "%'");

			if (!$counticons['count'])
			{
				$nextpage = 1;
				$type = 'smilies';
				print_description_row('      .   &quot;&quot;  ', '', 5);
			}
			else
			{

                        print_cells_row(array('<input type="checkbox" name="allbox" title=" " onclick="js_check_all(this.form);" checked="checked" /> ?', ' ', ' ', ' ', ' '), 'thead');

				$nextpage = $pagenumber + 1;

				if ($maxlimit > $counticons['count'])
				{
					$maxlimit = $counticons['count'];
					$nextpage = 1;
					$type = 'smilies';
				}
				if ($minlimit > $counticons['count'])
				{
					$minlimit = $counticons['count'] - $perpage;
				}

				if ($minlimit < 0)
				{
					$minlimit = 1;
				}

				$icons = $db->query("
						SELECT *
						FROM " . TABLE_PREFIX . "icon
						WHERE iconpath NOT LIKE '" . $vbulletin->options['bburl'] . "%'
						ORDER BY iconid
						LIMIT " . ($minlimit - 1) . ", $perpage
				");
				while ($icon = $db->fetch_array($icons))
				{
					construct_hidden_code('title[' . $icon['iconid'] . ']', $icon['title']);

					$paths = do_path_check($icon['iconpath']);

					echo '<tr class="' . $paths['class'] . '"><td align="left"><input type="checkbox" name="updateicon[' . $icon['iconid'] . ']" ' . $paths['checked'] . ' value="1" /></td><td>' . $icon['title'] . '</td><td align="center"><input name="iconpath[' . $icon['iconid'] . ']" type="text" value="' . $paths['newpath'] . '" size="50" /></td><td align="center"><img src="' . $icon['iconpath'] . '" /></td><td align="center"><img src="' . $paths['newpath'] . '" /></td></tr>';

				}
			}
			print_table_break();

		break;

		// ##### Smilies
		case 'smilies':

			print_table_header('   ', 5);


			$countsmilies = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "smilie WHERE smiliepath NOT LIKE '" . $vbulletin->options['bburl'] . "%'");

			$nextpage = $pagenumber + 1;

			if (!$countsmilies['count'])
			{
				$nextpage = 1;
				$type = 'styleimages';
				print_description_row('      .   &quot;&quot;  ', '', 5);
			}
			else
			{

				if ($maxlimit > $countsmilies['count'])
				{
					$maxlimit = $countsmilies['count'];
					$nextpage = 1;
					$type = 'styleimages';
				}
				if ($minlimit > $countsmilies['count'])
				{
					$minlimit = $countsmilies['count'] - $perpage;
				}

				if ($minlimit < 0)
				{
					$minlimit = 1;
				}

                                print_cells_row(array('<input type="checkbox" name="allbox" title=" " onclick="js_check_all(this.form);" checked="checked" /> ?', ' ', ' ', ' ', ' '), 'thead');

				$smilies = $db->query("
						SELECT * FROM " . TABLE_PREFIX . "smilie
						WHERE smiliepath NOT LIKE '" . $vbulletin->options['bburl'] . "%'
						ORDER BY smilieid
						LIMIT " . ($minlimit - 1) . ", $perpage
				");
				while ($smilie = $db->fetch_array($smilies))
				{
					construct_hidden_code('title[' . $smilie['smilieid'] . ']', $smilie['title']);

					$paths = do_path_check($smilie['smiliepath']);

					echo '<tr class="' . $paths['class'] . '"><td align="left"><input type="checkbox" name="updatesmilie[' . $smilie['smilieid'] . ']" ' . $paths['checked'] . 'value="1" /></td><td>' . $smilie['title'] . '</td><td align="center"><input name="smiliepath[' . $smilie['smilieid'] . ']" type="text" value="' . $paths['newpath'] . '" size="50" /></td><td align="center"><img src="' . $smilie['smiliepath'] . '" /></td><td align="center"><img src="' . $paths['newpath'] . '" /></td></tr>';
				}
			}

		break;

		// ##### Style Images
		case 'styleimages':

			print_table_header('   ', 5);
                        print_cells_row(array('<input type="checkbox" name="allbox" title=" " onclick="js_check_all(this.form);" checked="checked" /> ?', ' ', ' ', ' '), 'thead');

			// Get image titles & paths
			$scache = array();
			$styleimages = $db->query("
				SELECT * FROM " . TABLE_PREFIX . "template
				WHERE title IN('imgdir_attach', 'imgdir_button', 'imgdir_editor', 'imgdir_misc', 'imgdir_poll', 'imgdir_rating', 'imgdir_reputation', 'imgdir_statusicon', 'titleimage') OR (templatetype = 'css' AND template LIKE '%url(%' AND title != 'EXTRA')
			");
			while ($simage = $db->fetch_array($styleimages))
			{
				$scache["$simage[styleid]"]["$simage[title]"] = $simage['template'];
			}

			// Images to check for
			$stylechecks['imgdir_attach'] = '/attach.gif';
			$stylechecks['imgdir_button'] = '/reply_small.gif';
			$stylechecks['imgdir_editor'] = '/quote.gif';
			$stylechecks['imgdir_misc'] = '/stats.gif';
			$stylechecks['imgdir_poll'] = '/bar6-l.gif';
			$stylechecks['imgdir_rating'] = '/rating_5.gif';
			$stylechecks['imgdir_reputation'] = '/reputation_pos.gif';
			$stylechecks['imgdir_statusicon'] = '/forum_new.gif';

			// Get styles
			$styles = $db->query("SELECT styleid, title FROM " . TABLE_PREFIX . "style WHERE styleid != '-1' ORDER BY styleid, title");
			while ($style = $db->fetch_array($styles))
			{
				print_table_header($style['title'], 4, 0, '', $stylevar['left']);

				if (empty($scache["$style[styleid]"]))
				{
					$scache["$style[styleid]"] = $scache['-1'];
				}

				$defstyle = array_diff(array_keys($stylechecks), array_keys($scache["$style[styleid]"]));

				if (!empty($defstyle))
				{
					foreach ($defstyle AS $varname)
					{
						$scache["$style[styleid]"][$varname] = $scache['-1'][$varname];
					}
				}				

				foreach ($scache["$style[styleid]"] AS $varname => $imgpath)
				{
					if (substr($varname, 0, 1) == '.')
					{
						$classarray = unserialize($imgpath);
						$imgpath = $classarray['background'];
						$urlpos = strpos($imgpath, 'url(') + 4;
				    $imgpath = substr($imgpath, $urlpos, (strpos($imgpath, ')', $urlpos) - $urlpos));

						$namepos = strrpos($imgpath, '/');

						$imgcheck = substr($imgpath, $namepos, strlen($imgpath) - $namepos);
						$imgpath = substr($imgpath, 0, $namepos);

					}
					else
					{
						$imgcheck = $stylechecks["$varname"];
					}

					$paths = do_path_check($imgpath . $imgcheck);

					if (substr($varname, 0, 1) == '.')
					{
						$newpath = $paths['newpath'];
					}
					else
					{
						$newpath = substr($paths['newpath'], 0, intval(strlen($paths['newpath']) - strlen($imgcheck)));
					}

					echo '<tr class="' . $paths['class'] . '">
						<td align="left"><input type="checkbox" name="updatepath[' . $style['styleid'] . '][' . $varname . ']" ' . $paths['checked'] . ' value="1" /></td>
						<td>' . $varname . '</td>
						<td align="center"><input name="stylepath[' . $style['styleid'] . '][' . $varname . ']" type="text" value="' . $newpath . '" size="50" /></td>
						<td align="center"><div style="overflow: auto; width: 250px; height: 50px;"><img src="' . $paths['newpath'] . '" /></div></td></tr>';
				}

			}
		break;

		print_table_break();
		break;
	}

	construct_hidden_code('type', $type);
	construct_hidden_code('nextpage', $nextpage);
	print_submit_row('', '', 5);
}


// ##### Do Update Image Paths ################################################
if ($_POST['do'] == 'updateimages')
{
	$vbulletin->input->clean_array_gpc('p', array('updateicon', 'iconpath', 'updatesmilie', 'smiliepath', 'updatepath', 'stylepath', 'type' => TYPE_STR, 'nextpage' => TYPE_INT));

	$updateicon = $vbulletin->input->clean_gpc('p', 'updateicon');
	$iconpath = $vbulletin->input->clean_gpc('p', 'iconpath');
	$updatesmilie = $vbulletin->input->clean_gpc('p', 'updatesmilie');
	$smiliepath = $vbulletin->input->clean_gpc('p', 'smiliepath');
	$updatepath = $vbulletin->input->clean_gpc('p', 'updatepath');
	$stylepath = $vbulletin->input->clean_gpc('p', 'stylepath');
	$type = $vbulletin->input->clean_gpc('p', 'type');
	$nextpage = $vbulletin->input->clean_gpc('p', 'nextpage');

	if (is_array($updatepath))
	{
		// Get image titles & paths
		$defstyle = array();
		$styleimages = $db->query("
			SELECT title, template FROM " . TABLE_PREFIX . "template
			WHERE title IN('imgdir_attach', 'imgdir_button', 'imgdir_editor', 'imgdir_misc', 'imgdir_poll', 'imgdir_rating', 'imgdir_reputation', 'imgdir_statusicon', 'titleimage') OR (templatetype = 'css' AND template LIKE '%url(%') AND styleid = '-1'
		");
		while ($simage = $db->fetch_array($styleimages))
		{
			$defstyle["$simage[title]"] = $simage['template'];
		}
		
		foreach ($updatepath AS $sid => $values)
		{
			foreach ($values AS $var => $update)
			{
				if ($update)
				{
					$newtemp = $stylepath[$sid][$var];

					$checkit = $db->query_first("SELECT title, template FROM " . TABLE_PREFIX . "template WHERE title = '$var' AND styleid = '$sid'");

					if (substr($var, 0, 1) == '.')
					{
						if (!$checkit['title'])
						{
							$checkit['template'] = $defstyle[$var];
						}
						
						$template = unserialize($checkit['template']);

						$posone = strpos($template['background'], 'url(') + 4;
						$postwo = strpos($template['background'], ')', $posone);

						$partone = substr($template['background'], 0, $posone);
						$parttwo = substr($template['background'], $postwo, strlen($template['background']));

						$template['background'] = $partone . $newtemp . $parttwo;

						$newtemp = serialize($template);
					}

					if ($checkit['title'])
					{
						$db->query_write("UPDATE " . TABLE_PREFIX . "template SET template = '" . $db->escape_string($newtemp) . "' WHERE title = '$var' AND styleid = '$sid'");
					}
					else
					{
						$db->query_write("
							INSERT INTO " . TABLE_PREFIX . "template
								(styleid, title, template, template_un, templatetype, dateline, username, product)
							VALUES (
								'$sid',
								'$var',
								'" . $db->escape_string($newtemp) . "',
								'',
								'" . iif(substr($var, 0, 1) == '.', 'css', 'stylevar') . "',
								" . TIMENOW . ",
								'" . $db->escape_string($vbulletin->userinfo['username']) . "',
								'vbulletin'
						)");
					}
				}
			}
		}
		build_all_styles(0, 0, $scriptfile . '.php?do=install&step=finished');
	}

	// Update Icons
	if (is_array($updateicon))
	{
		echo '<b> ...</b><br />';
		foreach ($iconpath AS $key => $val)
		{
			if ($updateicon["$key"])
			{
				$db->query_write("UPDATE " . TABLE_PREFIX . "icon SET iconpath = '$val' WHERE iconid = '$key'");
				echo '<span class="smallfont"> : ' . $title[$key] . ' (' . $val . ')</span><br />';
			}
		}
		build_image_cache('icon');
	}

	// Update Smilies
	if (is_array($updatesmilie))
	{
		echo '<br /><br /><b> ...</b><br />';
		foreach ($smiliepath AS $key => $val)
		{
			if ($updatesmilie["$key"])
			{
				$db->query_write("UPDATE " . TABLE_PREFIX . "smilie SET smiliepath = '$val' WHERE smilieid = '$key'");
				echo '<span class="smallfont"> : ' . $title[$key] . ' (' . $val . ')</span><br />';
			}
		}
		build_image_cache('smilie');
	}

	if ($_POST['updateclear'])
	{
		$db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = 'clear.gif' WHERE varname = 'cleargifurl'");
		echo '<br />clear.gif .<br />';
		build_options();
	}

	if ($_POST['updatedicon'])
	{
		$db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = '$deficon' WHERE varname = 'showdeficon'");
		echo '<br />   .<br />';
		build_options();
	}

	if ($nextpage)
	{
		print_cp_redirect($scriptfile . '.php?do=doimages&type=' . $type . '&pagenumber=' . $nextpage);
	}
	else
	{
		print_cp_redirect($scriptfile . '.php?do=finished');
	}
}

// ##### Upgrade ##############################################################
if ($_REQUEST['do'] == 'upgrade')
{
	$step = intval($_REQUEST['step']);

	print_install_table_start(' vBadvanced ' . $scriptname, 'upgrade');

	$vcheck = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "adv_setting WHERE varname = 'portal_version'");

	if ($vcheck['value'] == $version)
	{
		$stepphrase = '     vBadvanced ' . $scriptname . '!';
		$nocontinue = 1;
	}
	else if (!$vcheck['value'])
	{
		$stepphrase = 'vBadvanced ' . $scriptname . '  !     " ".';
		$nocontinue = 1;
	}
	else
	{
		switch ($vcheck['value'])
		{
			case 'RC2':
			case '1.0.0':

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_settinggroup SET displayorder = displayorder+1 WHERE grouptitle LIKE 'adv_portal%'");

				$checkglobal = $db->query_first("SELECT grouptitle FROM " . TABLE_PREFIX . "adv_settinggroup WHERE grouptitle = 'adv_global'");

				if (!$checkglobal['grouptitle'])
				{
					$db->query_write("INSERT INTO " . TABLE_PREFIX . "adv_settinggroup VALUES ('adv_global', 1)");
					insert_phrase('settinggroup_adv_global', '  vBadvanced', 5000);
				}


			case '1.0.1':

				// Alter module table
				$db->query_write("
					ALTER TABLE " . TABLE_PREFIX . "adv_modules
					ADD parent varchar(255) NOT NULL default '',
					ADD colspan smallint(3) unsigned NOT NULL default '0',
					ADD formcode text NOT NULL,
					ADD cleanoutput smallint(3) unsigned NOT NULL default '0',
					ADD useshell smallint(3) unsigned NOT NULL default '0',
					ADD link varchar(255) NOT NULL default '',
					ADD options text NOT NULL,
					CHANGE filename filename text NOT NULL,
					CHANGE inctype inctype varchar(20) NOT NULL default ''
				");
				$stepphrase .= '  adv_modules    .<br />';

				// Alter page table
				$db->query_write("
					ALTER TABLE " . TABLE_PREFIX . "adv_pages ADD type varchar(50) NOT NULL default '' AFTER name,
					ADD parentid int(10) unsigned NOT NULL default '0' AFTER template,
					ADD parentlist varchar(255) NOT NULL default '' AFTER template,
					ADD active smallint(3) unsigned NOT NULL default '0',
					ADD colspan smallint(3) unsigned NOT NULL default '0',
					ADD formcode text NOT NULL,
					ADD cleanoutput smallint(3) unsigned NOT NULL default '0',
					ADD useshell smallint(34) unsigned NOT NULL default '0',
					ADD custom_title varchar(255) NOT NULL default '',
					CHANGE template template text NOT NULL
				");
				$stepphrase .= '  adv_pages    .<br /><br />';

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_pages SET active = 1");
				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_pages SET type = 'template' WHERE template != ''");
				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_pages SET type = 'module' WHERE type = ''");

				$getpsetting = $db->query_read("SELECT pageid, advanced FROM " . TABLE_PREFIX . "adv_pages WHERE advanced != ''");
				while ($psetting = $db->fetch_array($getpsetting))
				{
					$psetting['advanced'] = unserialize($psetting['advanced']);
					$pagesettings = array();
					if (!empty($psetting['advanced']))
					{
						foreach ($psetting['advanced'] AS $varname => $value)
						{
							$sgroup = $db->query_first("SELECT grouptitle FROM " . TABLE_PREFIX . "adv_setting WHERE varname = '$varname'");
							$pagesettings["$sgroup[grouptitle]"]["$varname"] = $value;
						}
					}
					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_pages SET advanced = '" . serialize($pagesettings) . "' WHERE pageid = '$psetting[pageid]'");
				}

				$stepphrase = '  .<br /><br />';

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET inctype = 'php_file' WHERE inctype = 0");
				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET inctype = 'template' WHERE inctype = 1");
				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET inctype = 'custom' WHERE inctype = 2");

				$db->query_write("INSERT INTO " . TABLE_PREFIX . "datastore (title) VALUES ('adv_portal_page')");

				// Update module usergroup perms
				$getoldmods = $db->query_read("SELECT modid, userperms FROM " . TABLE_PREFIX . "adv_modules");
				while ($oldmod = $db->fetch_array($getoldmods))
				{
					if (!$oldmod['userperms'])
					{
						$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET userperms = '" . implode(',', array_keys($vbulletin->usergroupcache)) . "' WHERE modid = '$oldmod[modid]'");
					}
				}

				// Update Modules
				foreach ($vba_modules AS $modid => $module)
				{
					if (in_array($module['identifier'], array('navigation', 'birthdays')))
					{
						if ($module['identifier'] == 'navigation')
						{
							$module['active'] = 0;
						}
						$module['userperms'] = implode(',', array_keys($vbulletin->usergroupcache));
						$db->query_read(fetch_query_sql($module, 'adv_modules'));
					}
					else
					{

						$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET identifier = '$module[identifier]', inctype = '$module[inctype]', templatelist = '$module[templatelist]', parent = '$module[parent]', colspan = '$module[colspan]', formcode = '$module[formcode]', useshell = '$module[useshell]', link = '$module[link]' WHERE filename = '$module[filename]' " . iif(in_array($module['filename'], array('news.php', 'onlineusers.php')), "AND identifier = '$module[identifier]'"));
					}
				}

				update_module_cache();

				$stepphrase .= ' .<br /><br />';

				// Update settings

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET grouptitle = 'adv_portal_calendar' WHERE varname = 'portal_calendarid'");
				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET grouptitle = 'adv_portal_style' WHERE varname IN('portal_shownavbar', 'portal_colspacing', 'portal_rightcolwidth', 'portal_leftcolwidth', 'portal_blockbullet')");

				$db->query_write("INSERT INTO " . TABLE_PREFIX . "adv_settinggroup VALUES ('adv_portal_style', 3)");

				$db->query_write("DELETE FROM " . TABLE_PREFIX . "template WHERE title IN('adv_portal', 'adv_portal_buddylist', 'adv_portal_buddylistbits', 'adv_portal_calendar', 'adv_portal_latesttopicbits', 'adv_portal_latesttopics', 'adv_portal_moderation', 'adv_portal_newsbits', 'adv_portal_news_archive', 'adv_portal_news_archivebits', 'adv_portal_onlineusers', 'adv_portal_poll', 'adv_portal_polloption', 'adv_portal_polloption_multiple', 'adv_portal_pollresult', 'adv_portal_search', 'adv_portal_stats', 'adv_portal_welcomeblock')");

				$chpoll = $db->query_first("SELECT value FROM " . TABLE_PREFIX . "adv_setting WHERE varname = 'portal_poll_forumid'");

				// Check poll value
				if ($chpoll['value'] == 'RAND')
				{
					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET value = '" . implode(',', array_keys($vbulletin->forumcache)) . "' WHERE varname = 'portal_poll_forumid'");
					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET value = 'rand' WHERE varname = 'portal_poll_orderby'");
				}

			case '2.0 RC1 (vB 3.5)':
			case '2.0 RC1':

				// Alter adv_pages table to include meta and displayorder
				$db->query_write("ALTER TABLE " . TABLE_PREFIX . "adv_pages ADD meta TEXT NOT NULL, ADD displayorder SMALLINT(4) UNSIGNED DEFAULT '0' NOT NULL");

				kill_phrase('edit_template_in_style', 'adv_portal_cp');

				$stepphrase .= ' .<br /><br />';

			case '2.0 RC2 (vB 3.5)':
			case '2.0 RC2':

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET colspan = 6 WHERE identifier = 'newsarchive'");
				$stepphrase .= '  .<br /><br />';

				kill_phrase('adv_portal_must_choose_file_include', 1000);

			case '2.0.0':

				// Update module links & form code
				$getmods = $db->query("SELECT modid, formcode, link FROM " . TABLE_PREFIX . "adv_modules");
				while ($mod = $db->fetch_array($getmods))
				{
					$mod['link'] = str_replace('$vboptions[bburl]', '{$vbulletin->options[bburl]}', $mod['link']);
					$mod['formcode'] = str_replace('$vboptions[bburl]', '{$vbulletin->options[bburl]}', $mod['formcode']);

					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET formcode = '$mod[formcode]', link = '$mod[link]' WHERE modid = '$mod[modid]'");
				}

				foreach ($vba_modules AS $modid => $module)
				{
					if ($module['link'])
					{
						$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET link = '" . $db->escape_string($module['link']) . "' WHERE identifier = '$module[identifier]'");
					}
				}

				update_module_cache();

			case '2.0.0 (vB 3.5)':

				$db->query_write("ALTER TABLE " . TABLE_PREFIX . "adv_modules, ADD COLUMN code_parsed text NOT NULL");
				$stepphrase .= '  adv_modules   code_parsed.<br /><br />';

				$db->query_write("ALTER TABLE " . TABLE_PREFIX . "adv_modules CHANGE templatelist templatelist TEXT NOT NULL");
				$stepphrase .= '  adv_modules       .';

				$freplace = $db->query_first("SELECT value FROM " . TABLE_PREFIX . "adv_setting WHERE varname = 'global_footer_replace'");

				$freplace['value'] = explode("\r\n", $freplace['value']);

				if (!in_array('profile.php', $freplace['value']))
				{
					$freplace['value'][] = 'profile.php';

					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET value = '" . $db->escape_string(implode("\r\n", $freplace['value'])) . "' WHERE varname = 'global_footer_replace'");
					$stepphrase = ' profile.php   footer.<br /><br />';
				}

				$db->query_write("ALTER TABLE " . TABLE_PREFIX . "session ADD newposts INT(10) UNSIGNED NULL");
				$stepphrase = '  session    .<br /><br />';

				include_once('./includes/class_bbcode.php');
				include_once('./includes/functions_forumdisplay.php');

				$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());

				$getmods = $db->query("SELECT modid, filename, options FROM " . TABLE_PREFIX . "adv_modules WHERE inctype = 'bb_code'");
				while ($mod = $db->fetch_array($getmods))
				{
					$setting = unserialize($mod['options']);

					$db->query_write("UPDATE " . TABLE_PREFIX . "adv_modules SET code_parsed = '" . $db->escape_string($bbcode_parser->do_parse($mod['filename'], $setting['allow_html'], $setting['allow_smilies'], 1, $setting['allow_image_code'])) . "' WHERE modid = '$mod[modid]'");
				}
				$stepphrase = '  BB .<br /><br />';

				$db->query_write("INSERT INTO " . TABLE_PREFIX . "product (productid, title, description, version, active) VALUES ('" . PRODUCT_CODE . "', 'vBadvanced CMPS', '   ', '" . $version . "', 1)");

				$stepphrase .= ' CMPS  .<br /><br />';

				$db->query_write("UPDATE " . TABLE_PREFIX . "plugin SET devkey = 'adv_error' WHERE devkey = 'vba_error'");

				foreach ($mainphrases AS $phrasetypeid => $phrases)
				{
					$db->query_write("UPDATE " . TABLE_PREFIX . "phrase SET product = '" . PRODUCT_CODE . "' WHERE fieldname = '$phrasetypeid' AND varname IN('" . implode('\', \'', array_keys($phrases)) . "')");
				}

				$stepphrase .= '/ .<br /><br />';


				$db->query_write("INSERT INTO " . TABLE_PREFIX . "datastore (title) VALUES ('adv_portal_tpst')");
				$stepphrase .= '       datastore.<br /><br />';

			case '2.1.0':

			case '2.2.0':

				$db->query_write("UPDATE " . TABLE_PREFIX . "datastore SET unserialize = 1 WHERE title IN('adv_portal_opts', 'adv_modules', 'adv_portal_page', 'adv_portal_tpst')");
				
				$stepphrase .= '    datastore.<br />';

				$db->query_write("UPDATE " . TABLE_PREFIX . "product SET description = '    vBadvanced' WHERE productid = '" . PRODUCT_CODE . "'");

				update_page_cache();				

			default:
				// Update Phrases
				insert_all_phrases();

				$stepphrase .= '/ .<br /><br />';
	
				// Templates
				insert_all_templates();

				$rebuildtemp = true;

				$stepphrase .= ' .<br /><br />';
				vbflush();

				foreach ($mainsettings AS $grouptitle => $settings)
				{
					foreach ($settings AS $varname => $setting)
					{
						if (!insert_setting())
						{
							update_setting();
						}
					}
				}

				$db->query_write("UPDATE " . TABLE_PREFIX . "adv_setting SET value = '$version' WHERE varname = 'portal_version'");
				$db->query_write("UPDATE " . TABLE_PREFIX . "product SET version = '" . $version . "' WHERE productid = '" . PRODUCT_CODE . "'");

				$stepphrase .= '  .<br /><br />';

				build_adv_settings();

				insert_plugins();

				if (in_array($vcheck['value'], array('1.0.0', '1.0.1', 'RC2')))
				{
					construct_hidden_code('redirect', 'finished');
					$nextdo = 'alttables';
				}
				else
				{
					$nextdo = 'finished';
				}

			break;


			default:
				$stepphrase = '   vBadvanced CMPS ,  1.0.0. ,  CMOS   1.0.0  1.0.1.';
		}
	}

	print_install_table_end();

}

// ##### Uninstall ############################################################
if ($_REQUEST['do'] == 'uninstall')
{
	$step = $_REQUEST['step'];
	$forumsoff = intval($_REQUEST['forumsoff']);

	print_install_table_start(' vBadvanced ' . $scriptname, 'uninstall');

	$db->reporterror = 0;

	switch ($step)
	{
		case 1:
			$stepphrase = ',     vBadvanced ' . $scriptname . '.     ,    vBadvanced ' . $scriptname . '.</div>';
		break;

		case 2:

			if ($vbulletin->options['bbactive'])
			{
				print_description_row(',     ', '', 2, 'thead');
				print_textarea_row('   :', 'closedmessage', $vbulletin->options['bbclosedreason'], 4, 40, 1, 0);
				construct_hidden_code('redirect', 'uninstall');
				$nextdo = 'closeforums';
			}
			else
			{
				print_cp_redirect($scriptfile . '.php?do=uninstall&amp;step=3');
			}

		break;

		case 3:

			$db->query_write("DROP TABLE " . TABLE_PREFIX . "adv_modules");
			$db->query_write("DROP TABLE " . TABLE_PREFIX . "adv_pages");

			$stepphrase .= ' .<br /><br />';

			foreach ($mainphrases AS $phrasetypeid => $phrases)
			{
				foreach ($phrases AS $varname => $text)
				{
					kill_phrase($phrase['varname'], $phrase['ptype']);
				}
			}

			$db->query_write("DELETE FROM " . TABLE_PREFIX . "phrasetype WHERE fieldname IN('adv_portal','adv_portal_cp')");

			$db->query_write("ALTER TABLE " . TABLE_PREFIX . "language DROP phrasegroup_adv_portal");
			$db->query_write("ALTER TABLE " . TABLE_PREFIX . "language DROP phrasegroup_adv_portal_cp");

			$stepphrase .= ' .<br /><br />';

			$db->query_write("DELETE FROM " . TABLE_PREFIX . "product WHERE productid = '" . PRODUCT_CODE . "'");

			$db->query_write("DELETE FROM " . TABLE_PREFIX . "plugin WHERE devkey IN('" . implode('\', \'', array_keys($vba_plugins)) . "')");

			$stepphrase .= '   .<br /><br />';

			$db->query_write("ALTER TABLE " . TABLE_PREFIX . "session DROP newposts");
			$stepphrase .= '  session   .<br /><br />';

			foreach ($maintemplates AS $name => $content)
			{
				kill_template($name);
			}

			$stepphrase .= ' .<br /><br />';

			foreach ($mainsettings AS $grouptitle => $settingsarray)
			{
				foreach ($settingsarray AS $varname => $setting)
				{
					kill_setting();
				}
			}

			$db->query_write("DELETE FROM " . TABLE_PREFIX . "adv_settinggroup WHERE grouptitle LIKE 'adv_portal%'");

			$stepphrase .= ' .<br /><br />';

			$db->query_write("DELETE FROM " . TABLE_PREFIX . "datastore WHERE title IN('adv_portal_opts', 'adv_modules', 'adv_portal_page', 'adv_portal_tpst')");

			vBulletinHook::build_datastore($db);

			$stepphrase .= '     datastore.<br />';

		break;

		case 4:
			$stepphrase = ' index    .<br />';
			flush();
			$db->query_write("ALTER TABLE" . TABLE_PREFIX . "user DROP INDEX (posts)");

		break;

		case 5:
			$stepphrase = ' index    .<br />';
			flush();
			$db->query_write("ALTER TABLE" . TABLE_PREFIX . "thread DROP INDEX (lastpost)");

		break;

		case 6:
			$stepphrase = ' index    .<br />';
			flush();
			$db->query_write("ALTER TABLE" . TABLE_PREFIX . "post DROP INDEX (dateline)");
			$nextstep = 'finished';

			if ($forumsoff)
			{
				$db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = 1 WHERE varname = 'bbactive'");
				build_options();

				$stepphrase .= '<br />   .';
			}

		break;

		case 'finished':

   $stepphrase = 'vBadvanced ' . $scriptname . '  .<br /> <br /><a href="index.php"><b>    --&gt;</b></a><br /><br /><a href="' . $scriptfile . '.php"><b>      --&gt;</b></a>';
			$nocontinue = 1;

		break;
	}

	print_install_table_end();
}

// ##### Rebuild Settings #####################################################
if ($_REQUEST['do'] == 'rebuildsettings')
{
	foreach ($mainsettings AS $grouptitle => $settings)
	{
		foreach ($settings AS $varname => $setting)
		{
			if (!insert_setting())
			{
				update_setting();
			}
		}
	}
	
	echo 'Settings rebuilt.';
}

// ##### Reinstall plugins ####################################################
if ($_REQUEST['do'] == 'plugins')
{
	insert_plugins();

	echo 'Plugins reinstalled.';
}

print_cp_footer();

?>