<?php
// ++=========================================================================++
// || vBadvanced CMPS v2.2.1 - Russian (Repack)
// ||  2003-2007 vBadvanced.com & PlurPlanet, LLC -   
// ||  : Lazek  zCarot.
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);

// ##################### Construct Global Templates Function #######################
function construct_global_templates(&$mod)
{
	global $globaltemplates;
	if ($mod['inctype'] == 'php_file')
	{
		if ($mod['templatelist'])
		{
			$adv_templates = explode(',', $mod['templatelist']);
			foreach ($adv_templates AS $a_temp)
			{
				$globaltemplates[] = trim($a_temp);
			}
		}
	}
	else if ($mod['filename'])
	{
		$globaltemplates[] = 'adv_portal_' . $mod['filename'];
	}
	return $globaltemplates;
}

$cmps_options =& $vbulletin->adv_portal_opts;

$portal_options = array_merge($cmps_options['adv_portal_main'], $cmps_options['adv_global']);

if (empty($vba_options))
{
	$vba_options = $portal_options;
}
else
{
	$vba_options = array_merge($vba_options, $portal_options);
}

$vba_style = $cmps_options['adv_portal_style'];

$pagevar = $vba_options['portal_pagevar'];

if (defined('VBA_PAGE'))
{
	$getpage = VBA_PAGE;
}
else if(isset($_REQUEST["$pagevar"]))
{
	$getpage = $_REQUEST["$pagevar"];
}
else
{
	$getpage = 'home';
}

$pages = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "adv_pages WHERE name = '" . $db->escape_string($getpage) . "' " . iif(!($permissions['adminpermissions'] & CANCONTROLPANEL), 'AND active = 1'));

if ($pages['styleid'] AND $pages['styleid'] != -1)
{
	$styleid = $pages['styleid'];
}

// Get the user's groups
$vbulletin->userinfo['usergrouparray'] = fetch_membergroupids_array($vbulletin->userinfo);

$allowview = false;

// Check user's groups against page permissions
if ($pages['userperms'])
{
	$pageperms = explode(',', $pages['userperms']);
	$allowview = (array_intersect($vbulletin->userinfo['usergrouparray'], $pageperms)) ? true : false;
}

$globaltemplates[] = 'adv_portal_module_shell';

if ($pages['template'])
{
	$globaltemplates[] = $pages['template'];
}

$getmodules =& $vbulletin->adv_modules;

$pagemodules = explode(',', $pages['modules']);

$modules = array();
$donemods = array();
if (!empty($getmodules))
{
	foreach ($getmodules AS $mod)
	{
		if (in_array($mod['modid'], $pagemodules))
		{
			if ($mod['userperms'] OR $mod['inctype'] == 'custom')
			{
				foreach ($vbulletin->userinfo['usergrouparray'] AS $ugroups)
				{
					if ((in_array($ugroups, explode(',', $mod['userperms'])) OR $mod['inctype'] == 'custom') AND !in_array($mod['modid'], $donemods))
					{
						construct_global_templates($mod);
						$modules["$mod[modid]"] = $mod;
						$donemods[] = $mod['modid'];
					}
				}
			}
		}
	}
}

unset($getmodules);

// Meta tags
$pages['meta'] = unserialize($pages['meta']);

if (!empty($pages['meta']))
{
	if ($pages['meta']['description'])
	{
		$vbulletin->options['description'] = $pages['meta']['description'];
	}
	if ($pages['meta']['keywords'])
	{
		$vbulletin->options['keywords'] = $pages['meta']['keywords'];
	}
}

?>