<?php
// ++=========================================================================++
// || vBadvanced CMPS v2.2.1 - Russian (Repack)
// ||  2003-2007 vBadvanced.com & PlurPlanet, LLC -   
// ||  : Lazek  zCarot.
// ++ ========================================================================++

// ######################### Current Poll #########################
$query = array();

switch ($mod_options['portal_poll_orderby'])
{
	case 'rand':
		$query['orderby'] = 'RAND()';
		break;
	case 'dateline':
		$query['orderby'] = 'poll.dateline';
		break;
	default:
		$query['orderby'] = $mod_options['portal_poll_orderby'];
}

$mod_options['portal_threadids'] = unserialize($mod_options['portal_threadids']);

if (!empty($mod_options['portal_threadids']))
{
	$mods['threadids'] = 'AND thread.threadid IN(' . implode(',', array_keys($mod_options['portal_threadids'])) . ')';
}
else if ($mod_options['portal_poll_forumid'])
{
	$mods['inforums'] = explode(',', $mod_options['portal_poll_forumid']);

	if ($mod_options['portal_applypermissions'])
	{
		$mods['inforums'] = array_diff($mods['inforums'], $adv_forumperms);
	}
	if (empty($mods['inforums']))
	{
		$mods['inforums'] = '';
		$mods['nodisplay'] = true;
	}
	else
	{
		$mods['inforums'] = 'AND thread.forumid IN(' . implode(',', $mods['inforums']) . ')';
	}
}

if (!$mods['inforums'] AND !empty($adv_forumperms) AND $mod_options['portal_applypermissions'])
{
	$mods['exforums'] = 'AND thread.forumid NOT IN(' . implode(',', $adv_forumperms) . ')';
}

if ($vbulletin->userinfo['userid'] OR $mod_options['portal_poll_orderby'] == 'votedate')
{
	$query['pollfields'] = ', voteoption';
	$query['polljoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'pollvote AS pollvote ON (pollvote.pollid = poll.pollid AND pollvote.userid = ' . $vbulletin->userinfo['userid'] . ')';
}

if (!$mods['nodisplay'])
{
	$pollmod = $db->query_first("
			SELECT thread.pollid, open, threadid, replycount, forumid, question, poll.dateline, options, votes, active, numberoptions, timeout, multiple, voters, public $query[pollfields]
			FROM " . TABLE_PREFIX . "poll AS poll
			INNER JOIN " . TABLE_PREFIX . "thread AS thread USING (pollid)
			$query[polljoin]
			WHERE open <> 10 AND visible = 1 AND active = 1
			" . iif($mod_options['portal_poll_cutoffdate'], 'AND thread.dateline > ' . (TIMENOW - $mod_options['portal_poll_cutoffdate'] * 86400)) .
			iif($ignusers, ' AND thread.postuserid NOT IN(' . $ignusers . ')') . "
			$mods[threadids]
			$mods[inforums]
			$mods[exforums]
			ORDER BY $query[orderby] $mod_options[portal_poll_direction]
	");

	if ($pollmod['pollid'])
	{
		$pollmod['question'] = $bbcode_parser->parse($pollmod['question'], 'nonforum', $mod_options['portal_poll_allowsmilies']);

		$splitoptions = explode('|||', $pollmod['options']);
		$splitvotes = explode('|||', $pollmod['votes']);

		$pollmod['nvotes'] = iif($pollmod['multiple'], $pollmod['voters'], array_sum($splitvotes));

		$pollforumperms = fetch_permissions($pollmod['forumid']);

		if (!$pollmod['active'] OR !$pollmod['open'] OR ($pollmod['dateline'] + ($pollmod['timeout'] * 86400) < TIMENOW AND $pollmod['timeout']) OR !($pollforumperms & $vbulletin->bf_ugp_forumpermissions['canvote']))
		{
			$pollmod['showresults'] = 1;

			$pollmod['message'] = iif(($pollforumperms & $vbulletin->bf_ugp_forumpermissions['canvote']), $vbphrase['this_poll_is_closed'], $vbphrase['you_may_not_vote_on_this_poll']);
		}

		if (fetch_bbarray_cookie('poll_voted', $pollmod['pollid']) OR $pollmod['voteoption'])
		{
			$pollmod['showresults'] = 1;
			$pollmod['message'] = $vbphrase['you_have_already_voted_on_this_poll'];
		}

		if (can_moderate($pollmod['forumid'], 'caneditpoll'))
		{
			$show['editpoll'] = true;
		}

		$pollbits = '';

		$option = '';

		foreach ($splitvotes AS $key => $value)
		{
			$option['question'] = $bbcode_parser->parse($splitoptions["$key"], '', $mod_options['portal_poll_allowsmilies']);

			$show['voteital'] = '';

			if ($pollmod['voteoption'] == ($key + 1))
			{
				$show['voteital'] = 1;
			}

			$option['votes'] = $value;
			$option['number'] = $key + 1;

			if ($pollmod['showresults'])
			{
				$option['percent'] = 0;
				if ($value)
				{
					$option['percent'] = vb_number_format($value / $pollmod['nvotes'] * 100, 2);
				}

				$option['graphicnumber'] = $option['number'] % 6 + 1;
				$option['barnumber'] = intval($option['percent'] * 1.4);

				eval('$pollbits .= "' . fetch_template('adv_portal_pollresult') . '";');
			}
			elseif ($pollmod['multiple'])
			{
				eval('$pollbits .= "' . fetch_template('adv_portal_polloption_multiple') . '";');
			}
			else
			{
				eval('$pollbits .= "' . fetch_template('adv_portal_polloption') . '";');
			}
		}

		eval('$home["$mods[modid]"][\'content\'] .= "' . fetch_template('adv_portal_poll') . '";');
	}
}

unset($pollbits, $pollmod, $option, $pollbits, $query);

?>