<?php
// ++=========================================================================++
// || vBadvanced CMPS v2.2.1 - Russian (Repack)
// ||  2003-2007 vBadvanced.com & PlurPlanet, LLC -   
// ||  : Lazek  zCarot.
// ++ ========================================================================++

if (!$show['guest'])
{
	$mods['title'] = $vbphrase['user_cp'];
	$mods['formcode'] = '';

	// Avatar
	if ($mod_options['portal_welcome_avatar'])
	{
		require_once('./includes/functions_user.php');
		$avatarurl = fetch_avatar_url($vbulletin->userinfo['userid']);

		if (!$avatarurl)
		{
			$avatarurl = $stylevar['imgdir_misc'] . '/noavatar.gif';
		}
		else
		{
			$avatarurl = $vbulletin->options['bburl'] . '/' . $avatarurl[0];
		}
	}

	$lastvisitdate = vbdate($mod_options['portal_welcome_lastvisit_date'], $vbulletin->userinfo['lastvisit'], '', '');
	$lastvisittime = vbdate($mod_options['portal_welcome_lastvisit_time'], $vbulletin->userinfo['lastvisit'], '', '');

	// Reputation
	if ($mod_options['portal_welcome_rep'])
	{
		require_once('./includes/functions_reputation.php');
		fetch_reputation_image($vbulletin->userinfo, $permissions);
		$reppower = fetch_reppower($vbulletin->userinfo, $permissions);
	}

	if ($mod_options['portal_welcome_rank'])
	{
		$vbulletin->userinfo['rank'] = str_replace('src="', 'src="' . $vbulletin->options['bburl'] . '/', $vbulletin->userinfo['rank']);
	}

	// New posts
	if ($mod_options['portal_welcome_newposts'])
	{
		if (strlen($vbulletin->session->vars['newposts']) > 0 AND !$vbulletin->options['threadmarking'])
		{
			$newposts = number_format($vbulletin->session->vars['newposts']);
		}
		else
		{
			$getnewposts = $db->query_first("
				SELECT COUNT(*) AS count
				FROM " . TABLE_PREFIX . "post AS post
				" . iif($vbulletin->options['threadmarking'], 
					'LEFT JOIN ' . TABLE_PREFIX . 'threadread AS threadread ON (threadread.threadid = post.threadid AND threadread.userid = ' . $vbulletin->userinfo['userid'] . ')') . "
				WHERE dateline >= " . $vbulletin->userinfo['lastvisit'] . iif($vbulletin->options['threadmarking'], ' AND dateline > IF(threadread.readtime IS NULL, ' . (TIMENOW - ($vbulletin->options['markinglimit'] * 86400)) . ', threadread.readtime)')
			);

			if (!$vbulletin->options['threadmarking'])
			{
				$db->query_write("UPDATE " . TABLE_PREFIX . "session SET newposts = '$getnewposts[count]' WHERE userid = '" . $vbulletin->userinfo['userid'] . "'");
			}

			$newposts = vb_number_format($getnewposts['count']);
		}
	}

	$vbulletin->userinfo['pmtotal'] = vb_number_format($vbulletin->userinfo['pmtotal']);
	$permissions['pmquota'] = vb_number_format($permissions['pmquota']);
	$vbulletin->userinfo['pmunread'] = vb_number_format($vbulletin->userinfo['pmunread']);
}
else
{
	$mods['title'] = $vbphrase['log_in'];
	$mods['link'] = '';
}

eval('$home["$mods[modid]"][\'content\'] = "' . fetch_template('adv_portal_welcomeblock') . '";');

?>